/*
 * FilterWindow.java
 */

package paldirvd;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;



public class FilterWindow extends javax.swing.JFrame {
    
    private VDWindow vdView;
    private Vector vds_all, vds_filt;
    private static String RESULTANT = "R";
    private static String DIFFERENCE = "D";
    private static String PLANE = "P";
    private static String VECTOR = "V";
    private static Color COLOR3=new Color(164,122,53), COLOR4=new Color(238,162,54), COLOR1=new Color(14,55,172), COLOR2=new Color(87,128,252);

    /** Creates new form FilterWindow */
    public FilterWindow(VDWindow vd_view, String step_ini, String step_end, String num_steps, String min_int, String max_int, String min_mad, String max_mad) {
        initComponents();
        stepIniInput.setText(step_ini);
        stepEndInput.setText(step_end);
        numStepsInput.setText(num_steps);
        minIntInput.setText(min_int);
        maxIntInput.setText(max_int);
        minMadInput.setText(min_mad);
        maxMadInput.setText(max_mad);
        vdView = vd_view;
        vd_view.setEnabled(false);
        vd_view.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setLocationRelativeTo(vd_view);
        addWindowListener(new FrameListener());
        //vdView.setVisible(false);

        this.setTitle("Filtering Menu");
        vds_all = vdView.getVds();
        counterAll();

        refresh();
        
    }
    
    
    class FrameListener extends WindowAdapter
    {
       public void windowClosing(WindowEvent e){
           vdView.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
           vdView.setEnabled(true);

      }
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        stepIniInput = new javax.swing.JTextField();
        stepEndInput = new javax.swing.JTextField();
        numStepsInput = new javax.swing.JTextField();
        minMadInput = new javax.swing.JTextField();
        okButton = new javax.swing.JButton();
        stepsPanel = new javax.swing.JPanel();
        madPanel = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        maxIntInput = new javax.swing.JTextField();
        minIntInput = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        maxMadInput = new javax.swing.JTextField();
        refreshButton = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        counterPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        RVTotalCounter = new javax.swing.JTextField();
        RCCounter = new javax.swing.JTextField();
        DVCounter = new javax.swing.JTextField();
        DCCounter = new javax.swing.JTextField();
        RVCounter = new javax.swing.JTextField();
        DVTotalCounter = new javax.swing.JTextField();
        RCTotalCounter = new javax.swing.JTextField();
        DCTotalCounter = new javax.swing.JTextField();
        logoPanel = new javax.swing.JPanel();
        woodcocksPanel = new javax.swing.JPanel();
        intensityPanel = new javax.swing.JPanel();
        jLabel20 = new javax.swing.JLabel();

        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setLocationByPlatform(true);

        jLabel2.setText("Initial step");

        jLabel3.setText("Final step");

        jLabel4.setText("Steps' number");

        jLabel5.setText("Min MAD");

        okButton.setText("ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        stepsPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        stepsPanel.setMinimumSize(new java.awt.Dimension(200, 200));
        stepsPanel.setPreferredSize(new java.awt.Dimension(320, 320));

        org.jdesktop.layout.GroupLayout stepsPanelLayout = new org.jdesktop.layout.GroupLayout(stepsPanel);
        stepsPanel.setLayout(stepsPanelLayout);
        stepsPanelLayout.setHorizontalGroup(
            stepsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 329, Short.MAX_VALUE)
        );
        stepsPanelLayout.setVerticalGroup(
            stepsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 316, Short.MAX_VALUE)
        );

        madPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        madPanel.setMinimumSize(new java.awt.Dimension(200, 200));
        madPanel.setPreferredSize(new java.awt.Dimension(320, 320));

        org.jdesktop.layout.GroupLayout madPanelLayout = new org.jdesktop.layout.GroupLayout(madPanel);
        madPanel.setLayout(madPanelLayout);
        madPanelLayout.setHorizontalGroup(
            madPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 331, Short.MAX_VALUE)
        );
        madPanelLayout.setVerticalGroup(
            madPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 316, Short.MAX_VALUE)
        );

        jLabel6.setText("DEMAGNETIZATION STEPS");

        jLabel7.setText("MAD (º)");

        jLabel8.setText("INTENSITY (E-6 A/m)");

        jLabel9.setText("Min Intensity");

        jLabel10.setText("Max Intensity");

        jLabel11.setText("E-6 A/m");

        jLabel12.setText("E-6 A/m");

        jLabel13.setText("Max MAD");

        refreshButton.setText("Refresh graphics");
        refreshButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshButtonActionPerformed(evt);
            }
        });

        saveButton.setText("Save graphics (EPS)");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        counterPanel.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel1.setText("VIRTUAL COUNTER");

        jLabel14.setText("Resultant Directions");

        jLabel15.setText("Difference Directions");

        jLabel16.setText("Resultant Circles");

        jLabel17.setText("Difference Circles");

        jLabel18.setText("Total");

        jLabel19.setText("After filtering");

        RVTotalCounter.setEditable(false);

        RCCounter.setEditable(false);

        DVCounter.setEditable(false);

        DCCounter.setEditable(false);

        RVCounter.setEditable(false);

        DVTotalCounter.setEditable(false);

        RCTotalCounter.setEditable(false);

        DCTotalCounter.setEditable(false);

        org.jdesktop.layout.GroupLayout counterPanelLayout = new org.jdesktop.layout.GroupLayout(counterPanel);
        counterPanel.setLayout(counterPanelLayout);
        counterPanelLayout.setHorizontalGroup(
            counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(counterPanelLayout.createSequentialGroup()
                .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(counterPanelLayout.createSequentialGroup()
                        .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(counterPanelLayout.createSequentialGroup()
                                .add(30, 30, 30)
                                .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel15)
                                    .add(jLabel17)
                                    .add(jLabel16)
                                    .add(jLabel14))
                                .add(18, 18, 18)
                                .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(DVTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(RVTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(RCTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(DCTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(49, 49, 49))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, counterPanelLayout.createSequentialGroup()
                                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(jLabel18)
                                .add(83, 83, 83)))
                        .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(DCCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(RCCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(DVCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(RVCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(counterPanelLayout.createSequentialGroup()
                                .add(11, 11, 11)
                                .add(jLabel19))))
                    .add(counterPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel1)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        counterPanelLayout.setVerticalGroup(
            counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(counterPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .add(18, 18, 18)
                .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel18)
                    .add(jLabel19))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(counterPanelLayout.createSequentialGroup()
                        .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(RVTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel14))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(DVTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel15))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(RCTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(RCCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel16))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(counterPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(DCTotalCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(DCCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel17)))
                    .add(counterPanelLayout.createSequentialGroup()
                        .add(RVCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(4, 4, 4)
                        .add(DVCounter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        logoPanel.setPreferredSize(new java.awt.Dimension(170, 48));

        org.jdesktop.layout.GroupLayout logoPanelLayout = new org.jdesktop.layout.GroupLayout(logoPanel);
        logoPanel.setLayout(logoPanelLayout);
        logoPanelLayout.setHorizontalGroup(
            logoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 170, Short.MAX_VALUE)
        );
        logoPanelLayout.setVerticalGroup(
            logoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 48, Short.MAX_VALUE)
        );

        woodcocksPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        woodcocksPanel.setMaximumSize(new java.awt.Dimension(400, 400));
        woodcocksPanel.setMinimumSize(new java.awt.Dimension(300, 200));
        woodcocksPanel.setPreferredSize(new java.awt.Dimension(320, 320));

        org.jdesktop.layout.GroupLayout woodcocksPanelLayout = new org.jdesktop.layout.GroupLayout(woodcocksPanel);
        woodcocksPanel.setLayout(woodcocksPanelLayout);
        woodcocksPanelLayout.setHorizontalGroup(
            woodcocksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 316, Short.MAX_VALUE)
        );
        woodcocksPanelLayout.setVerticalGroup(
            woodcocksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 324, Short.MAX_VALUE)
        );

        intensityPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        intensityPanel.setMinimumSize(new java.awt.Dimension(200, 200));
        intensityPanel.setPreferredSize(new java.awt.Dimension(320, 320));

        org.jdesktop.layout.GroupLayout intensityPanelLayout = new org.jdesktop.layout.GroupLayout(intensityPanel);
        intensityPanel.setLayout(intensityPanelLayout);
        intensityPanelLayout.setHorizontalGroup(
            intensityPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 329, Short.MAX_VALUE)
        );
        intensityPanelLayout.setVerticalGroup(
            intensityPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 316, Short.MAX_VALUE)
        );

        jLabel20.setText("WOODCOCK'S (1977) DIAGRAM");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel6)
                    .add(layout.createSequentialGroup()
                        .add(woodcocksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(124, 124, 124)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(counterPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(layout.createSequentialGroup()
                                        .add(refreshButton)
                                        .add(41, 41, 41)
                                        .add(saveButton)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(okButton)))
                                .add(159, 159, 159))
                            .add(layout.createSequentialGroup()
                                .add(213, 213, 213)
                                .add(logoPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(stepsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 333, Short.MAX_VALUE)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel4)
                                    .add(jLabel3)
                                    .add(jLabel2))
                                .add(30, 30, 30)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, stepEndInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(numStepsInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                    .add(stepIniInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                        .add(18, 18, 18)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(intensityPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 333, Short.MAX_VALUE)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel9)
                                    .add(jLabel10))
                                .add(30, 30, 30)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(layout.createSequentialGroup()
                                        .add(minIntInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(24, 24, 24)
                                        .add(jLabel11))
                                    .add(layout.createSequentialGroup()
                                        .add(maxIntInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(jLabel12))))
                            .add(jLabel8))
                        .add(18, 18, 18)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel7)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel5)
                                    .add(jLabel13))
                                .add(30, 30, 30)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(minMadInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(maxMadInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(madPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 335, Short.MAX_VALUE)))
                    .add(jLabel20))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jLabel6)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel8)
                        .add(jLabel7)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.CENTER)
                    .add(stepsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(intensityPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(madPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(minIntInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel9)
                            .add(jLabel11))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(maxIntInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel10)
                            .add(jLabel12)))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(stepIniInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel2))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel3)
                            .add(stepEndInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel4)
                            .add(numStepsInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel5)
                            .add(minMadInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel13)
                            .add(maxMadInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(18, 18, 18)
                .add(jLabel20)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(refreshButton)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                .add(okButton)
                                .add(saveButton)))
                        .add(18, 18, 18)
                        .add(counterPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18)
                        .add(logoPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(11, 11, 11))
                    .add(woodcocksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
       enter();
       vdView.setEnabled(true);
       vdView.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
       this.setVisible(false);
    }//GEN-LAST:event_okButtonActionPerformed

    private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshButtonActionPerformed
       refresh();
    }//GEN-LAST:event_refreshButtonActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
       save();
    }//GEN-LAST:event_saveButtonActionPerformed

    private void enter(){
         
        String stepIni = stepIniInput.getText();
        String stepEnd = stepEndInput.getText();
        String numSteps = numStepsInput.getText();
        String minInt = minIntInput.getText();
        String maxInt = maxIntInput.getText();
        String minMad = minMadInput.getText();
        String maxMad = maxMadInput.getText();
        
        if(stepIni.equals("")) stepIni = "0";
        if(stepEnd.equals("")) stepEnd = "1000";
        if(numSteps.equals("")) numSteps = "0";
        if(minInt.equals("")) minInt = "0";
        if(maxInt.equals("")) maxInt = "1000";
        if(minMad.equals("")) minMad = "0";
        if(maxMad.equals("")) maxMad = "1000";

        try{
            double step_ini = Double.parseDouble(stepIni);
            double step_end = Double.parseDouble(stepEnd);
            int num_steps = Integer.parseInt(numSteps);
            double min_int = Double.parseDouble(minInt);
            double max_int = Double.parseDouble(maxInt);
            double min_mad = Double.parseDouble(minMad);
            double max_mad = Double.parseDouble(maxMad);
            
            vdView.setFilterParams(step_ini, step_end, num_steps, min_int, max_int, min_mad, max_mad);

            vds_filt = vdView.getVdsFilt();

        }catch(Exception ex){
            JOptionPane.showMessageDialog(this.rootPane, "Data is not valid");
        }
    }

    private void refresh(){
        enter();

        stepsPanel.paint(stepsPanel.getGraphics());
        plotSteps(stepsPanel.getGraphics(), stepsPanel.getSize(), vdView);
        intensityPanel.paint(intensityPanel.getGraphics());
        plotIntensity(intensityPanel.getGraphics(), intensityPanel.getSize(),vds_filt);
        madPanel.paint(madPanel.getGraphics());
        plotMad(madPanel.getGraphics(), madPanel.getSize(),vds_filt);
        woodcocksPanel.paint(woodcocksPanel.getGraphics());
        plotWoodcock(woodcocksPanel.getGraphics(), woodcocksPanel.getSize(),vds_filt, vds_all);

        counter();
    }

    public void paint(Graphics g){
        super.paint(getGraphics());
        paintComponent(g);
        paintLegend(g);
        refresh();
    }

    public void paintComponent(Graphics g) {
        g=logoPanel.getGraphics();
        ImageIcon imag = new ImageIcon("logoVPD.jpg");
        g.drawImage(imag.getImage(), 0, 0,  imag.getIconWidth() ,  imag.getIconHeight(), null);
        logoPanel.paintComponents(g);
    }

    public void paintLegend(Graphics g) {
        g=counterPanel.getGraphics();
        Dimension tam = counterPanel.getSize(); int Dy = tam.height; int w = 10;
        g.setColor(COLOR1);
        g.fillOval(w, 77, w, w);
        g.setColor(COLOR2);
        g.fillOval(w, 103, w, w);
        g.setColor(COLOR3);
        g.fillOval(w, 129, w, w);
        g.setColor(COLOR4);
        g.fillOval(w, 155, w, w);
        counterPanel.paintComponents(g);

    }

    public static void plotSteps(Graphics g, Dimension tam, VDWindow vd_view){
      //Filtering doesn't affect this graphic. It only count the steps

      //INITIALIZE GRAPHIC
      int d0 = 60;
      int Dx = tam.width; Dx=Dx-d0; int Dy = tam.height; Dy=Dy-d0;
      int x0 = d0/2; int y0 = (int) (tam.getHeight() - d0 / 2); // sw corner

      g.setColor (Color.GRAY);
      g.drawLine(x0, y0, x0+Dx, y0); // axes
      g.drawLine(x0, y0 , x0, y0-Dy);

      g.setFont(new Font("Tahoma", 0, 10)); g.setColor(Color.DARK_GRAY);
      g.drawString("Demagnetization level", x0+Dx/4, y0+25); //xlabel
      g.drawString("# of demagnetization steps", x0-25, y0-Dy-15); //ylabel
      g.setFont(new Font("Tahoma", 0, 8)); g.setColor(Color.GRAY);

      //DATA
      Vector finalSite = vd_view.getFinalSite();
      Vector steps; double step, maxStep=1;
      int counter, maxCounter=1; Vector stepsLabel = new Vector();
      HashMap stepCounter = new HashMap() {};
      for(int i=0; i<finalSite.size(); i++){
        steps = ((Core)finalSite.get(i)).getSteps();
        for (int j=0; j<steps.size(); j++){
            step = ((Step)steps.get(j)).getTemp();
            if(stepCounter.containsKey(step)){
                  counter = (Integer)stepCounter.get(step); counter++;
                  stepCounter.put(step,counter);
                  if(maxCounter<counter) maxCounter=counter;
            }else{
                  stepCounter.put(step,0);
                  stepsLabel.add(step);
                  if(maxStep<step) maxStep=step;
            }
        }
      }
      double x; int y, x1,y1; int w = Math.min(Dx, Dy)/40;
      for(int i=0; i<stepsLabel.size(); i++){ //set xLabel
          x = (Double)stepsLabel.get(i);
          y = (Integer)stepCounter.get(x);
          x1 = (int)(x0 + x*Dx/maxStep);
          y1 = (int)(y0 - y*Dy/maxCounter);
          g.setColor(Color.DARK_GRAY); 
          g.fillOval(x1-w/2,y1-w/2,w,w);
          /*g.setColor(Color.GRAY);
          g.drawString(Integer.toString((int)x), x1, y0+d0/5); //xLabel
          g.drawString(Integer.toString(y), x0-d0/5, y1); //yLabel*/
      }
      g.setColor(Color.GRAY);
      int N = (int) maxCounter/2;
      for(int i=0; i<=N; i++){
          y = 2*i;
          y1 = (int)(y0 - y*Dy/maxCounter);
          g.drawString(Integer.toString(y), x0-d0/5, y1); //yLabel
      }
      N = (int) maxStep/100;
      for(int i=0; i<=N; i++){
          x = 100*i;
          x1 = (int)(x0 + x*Dx/maxStep);
          g.drawString(Integer.toString((int)x), x1, y0+d0/5); //xLabel
      }
    }
    public static void plotIntensity(Graphics g, Dimension tam, Vector vdsFilt){

      //INITIALIZE GRAPHIC
      int Dx = tam.width; int Dy = tam.height;
      int d0 = 60; int dx = (Dx-d0) / 10; int dy = (Dy-d0) /10;
      int x0 = d0/2; int y0 = tam.height-d0/2; // sw corner

      g.setColor (Color.GRAY);
      g.drawLine(x0, y0, x0+Dx-d0, y0); // axes
      g.drawLine(x0, y0 , x0, y0-Dy+d0);

      g.setFont(new Font("Tahoma", 0, 10)); g.setColor(Color.DARK_GRAY);
      g.drawString("Intensity (E-6A/m)", x0+Dx/4, y0+25); //xlabel
      g.drawString("#", x0-25, y0-Dy/2); //ylabel
      g.setFont(new Font("Tahoma", 0, 8));

      //HISTOGRAM
      int i; Vector vds; VD vd; Position pos;
      vds = VirtualDirections.getRV(vdsFilt); //Resultant directions
      double data1[] = new double[vds.size()];
      for(i=0; i<vds.size(); i++){
          vd = (VD)vds.get(i);
          pos = vd.getPos(); pos.round();
          data1[i]=pos.getInt();
      }
      vds = VirtualDirections.getDV(vdsFilt); //Difference directions
      double data2[] = new double[vds.size()];
      for(i=0; i<vds.size(); i++){
          vd = (VD)vds.get(i);
          pos = vd.getPos(); pos.round();
          data2[i]=pos.getInt();
      }
      Arrays.sort(data1);
      Arrays.sort(data2);
      int N=10; //number of columns in the histogram
      double minX = Math.min(data1[0],data2[0]), maxX = Math.max(data1[data1.length-1],data2[data2.length-1]);
      double incX = (maxX-minX)/N;
      Vector xLabel = new Vector(N), hist = new Vector(N), hist1 = new Vector(N), hist2 = new Vector(N),  yLabel = new Vector(N);
      double aux, maxY=0;

      for(i=0; i<N+1; i++){ //set xLabel
          xLabel.add(Math.round((minX+i*incX)*10)/10d);
          hist.add(0d); hist1.add(0d); hist2.add(0d);
          yLabel.add(0);
      }

      i=0;
      for(int j=0; j<data1.length; j++){ //set hist and yLabel
         //System.out.println("dato1: "+data1[j]+", xLabel i: "+xLabel.get(i)+", xLabel i+1: "+xLabel.get(i+1));
         if( data1[j]>=(Double)xLabel.get(i) && data1[j]<=(Double)xLabel.get(i+1) ){
            aux = (Double)hist.get(i)+1;
            hist1.set(i, aux);
            hist.set(i, aux);
            yLabel.set(i,(int)aux);
            //System.out.println("dato1: "+data1[j]+", hist: "+hist.get(i)+", hist1: "+hist1.get(i));
            if(aux>maxY) maxY=aux;}
        else{
            i++; j--; }
      }
      i=0;
      for(int j=0; j<data2.length; j++){ //set hist and yLabel
        //System.out.println("dato2: "+data2[j]+", xLabel i: "+xLabel.get(i)+", xLabel i+1: "+xLabel.get(i+1));
        if( data2[j]>=(Double)xLabel.get(i) && data2[j]<=(Double)xLabel.get(i+1) ){
            aux = (Double)hist.get(i)+1;
            hist.set(i, aux);
            yLabel.set(i,(int)aux);
            hist2.set(i, (Double)hist2.get(i)+1);
            //System.out.println("dato2: "+data2[j]+", hist: "+hist.get(i)+", hist2: "+hist2.get(i));
            if(aux>maxY) maxY=aux;}
        else{
            i++; j--;}
      }

      //PLOT GRAPHIC
      int x1=0,x2=0,y=0;
      int xPoints[]= {x1,x2,x2,x1};
      int yPoints[] = {y0,y0,y,y};

      for(i=0; i<N; i++){

         x1=i*dx+x0; x2=(i+1)*dx+x0 -2;
         y=y0-(int)((Double)hist2.get(i)*N/maxY*dy);
         xPoints[0]=x1; xPoints[1]=x2; xPoints[2]=x2; xPoints[3]=x1; yPoints[0]=y0; yPoints[1]=y0; yPoints[2]=y; yPoints[3]=y;

         g.setColor(COLOR1);
         g.fillPolygon(xPoints,yPoints,4);

         yPoints[0]=y; yPoints[1]=y;
         y=y0-(int)((Double)hist.get(i)*N/maxY*dy); yPoints[2]=y; yPoints[3]=y;
         g.setColor(COLOR2);
         g.fillPolygon(xPoints,yPoints,4);

         g.setColor(Color.GRAY);
         if(i%2==0)
         g.drawString(Double.toString((Double)xLabel.get(i)), x1, y0+d0/5); //xLabel
         //g.drawString(Integer.toString((Integer)yLabel.get(i)), x0-d0/5, y); //yLabel
      }
      g.drawString(Double.toString((Double)xLabel.get(N)), x1+dx, y0+d0/5); //xLabel
      //g.drawString((Integer.toString((Integer)yLabel.get(N))), x0-d0/5, y0-(int)((Double)hist.get(N)*dy)); //yLabel

      /*//Legend
      g.setFont(new Font("Tahoma", 0, 10));
      g.setColor(Color.DARK_GRAY);
      g.drawString("Resultant directions", x0+Dx-150, y0-Dy+d0);
      g.setColor(Color.BLUE);
      g.drawString("Difference directions", x0+Dx-150, y0-Dy+d0+15);*/

      for(i=0; i<=5; i++){
          y = (int)(1d*maxY/5*i);
          g.drawString(Integer.toString(y), x0-d0/5, (int)(y0 - y*Dy/maxY)); //yLabel
      }
    }

    public static void plotMad(Graphics g, Dimension tam, Vector vdsFilt){

      //INITIALIZE GRAPHIC
      int Dx = tam.width; int Dy = tam.height;
      int d0 = 60; int dx = (Dx-d0) / 10; int dy = (Dy-d0) / 10;
      int x0 = d0/2; int y0 = tam.height-d0/2; // sw corner

      g.setColor (Color.GRAY);
      g.drawLine(x0, y0, x0+Dx-d0, y0); // axes
      g.drawLine(x0, y0 , x0, y0-Dy+d0);

      g.setFont(new Font("Tahoma", 0, 10)); g.setColor(Color.DARK_GRAY);
      g.drawString("MAD (º)", x0+Dx/3, y0+25); //xlabel
      g.drawString("#", x0-25, y0-Dy/2); //ylabel
      g.setFont(new Font("Tahoma", 0, 8));

      //HISTOGRAM
      int i; Vector vds; VD vd; Position pos;
      vds = VirtualDirections.getRV(vdsFilt); //Resultant directions
      double data1[] = new double[vds.size()];
      for(i=0; i<vds.size(); i++){
          vd = (VD)vds.get(i);
          pos = vd.getPos(); pos.round();
          data1[i]=pos.getError();
      }
      vds = VirtualDirections.getDV(vdsFilt); //Difference directions
      double data2[] = new double[vds.size()];
      for(i=0; i<vds.size(); i++){
          vd = (VD)vds.get(i);
          pos = vd.getPos(); pos.round();
          data2[i]=pos.getError();
      }
      vds = VirtualDirections.getRP(vdsFilt); //Resultant circles
      double data3[] = new double[vds.size()];
      for(i=0; i<vds.size(); i++){
          vd = (VD)vds.get(i);
          pos = vd.getPos(); pos.round();
          data3[i]=pos.getError();
      }
            vds = VirtualDirections.getDP(vdsFilt); //Difference circles
      double data4[] = new double[vds.size()];
      for(i=0; i<vds.size(); i++){
          vd = (VD)vds.get(i);
          pos = vd.getPos(); pos.round();
          data4[i]=pos.getError();
      }
      Arrays.sort(data1); Arrays.sort(data2); Arrays.sort(data3); Arrays.sort(data4);
      int N=10; //number of columns in the histogram
      double minX1 = Math.min(data1[0],data2[0]), minX2 = Math.min(data3[0],data4[0]), minX = Math.min(minX1, minX2);
      double maxX1 = Math.max(data1[data1.length-1],data2[data2.length-1]), maxX2 = Math.max(data3[data3.length-1],data4[data4.length-1]), maxX = Math.max(maxX1, maxX2);
      double incX = (maxX-minX)/N;
      Vector xLabel = new Vector(N), hist = new Vector(N), hist1 = new Vector(N), hist2 = new Vector(N), hist3 = new Vector(N), hist4 = new Vector(N),  yLabel = new Vector(N);
      double aux, maxY=0;

      for(i=0; i<N+1; i++){ //set xLabel
          xLabel.add(Math.round((minX+i*incX)*10)/10d);
          hist.add(0d); hist1.add(0d); hist2.add(0d); hist3.add(0d); hist4.add(0d);
          yLabel.add(0);
      }

      i=0;
      for(int j=0; j<data1.length; j++){ //set hist1 and yLabel
         //System.out.println("dato1: "+data1[j]+", xLabel i: "+xLabel.get(i)+", xLabel i+1: "+xLabel.get(i+1));
         if( data1[j]>=(Double)xLabel.get(i) && data1[j]<=(Double)xLabel.get(i+1) ){
            aux = (Double)hist.get(i)+1;
            hist1.set(i, aux);
            hist.set(i, aux);
            yLabel.set(i,(int)aux);
            //System.out.println("dato1: "+data1[j]+", hist: "+hist.get(i)+", hist1: "+hist1.get(i));
            if(aux>maxY) maxY=aux;}
        else{
            i++; j--; }
      }
      i=0;
      for(int j=0; j<data2.length; j++){ //set hist2 and yLabel
        //System.out.println("dato2: "+data2[j]+", xLabel i: "+xLabel.get(i)+", xLabel i+1: "+xLabel.get(i+1));
        if( data2[j]>=(Double)xLabel.get(i) && data2[j]<=(Double)xLabel.get(i+1) ){
            aux = (Double)hist.get(i)+1;
            hist.set(i, aux);
            yLabel.set(i,(int)aux);
            hist2.set(i, (Double)hist2.get(i)+1);
            //System.out.println("dato2: "+data2[j]+", hist: "+hist.get(i)+", hist2: "+hist2.get(i));
            if(aux>maxY) maxY=aux;}
        else{
            i++; j--;}
      }
      i=0;
      for(int j=0; j<data3.length; j++){ //set hist3 and yLabel
        if( data3[j]>=(Double)xLabel.get(i) && data3[j]<=(Double)xLabel.get(i+1) ){
            aux = (Double)hist.get(i)+1;
            hist.set(i, aux);
            yLabel.set(i,(int)aux);
            hist3.set(i, (Double)hist3.get(i)+1);
            if(aux>maxY) maxY=aux;}
        else{
            i++; j--;}
      }
      i=0;
      for(int j=0; j<data4.length; j++){ //set hist2 and yLabel
        if( data4[j]>=(Double)xLabel.get(i) && data4[j]<=(Double)xLabel.get(i+1) ){
            aux = (Double)hist.get(i)+1;
            hist.set(i, aux);
            yLabel.set(i,(int)aux);
            hist4.set(i, (Double)hist4.get(i)+1);
            if(aux>maxY) maxY=aux;}
        else{
            i++; j--;}
      }

      //PLOT GRAPHIC
      int x1=0,x2=0,y=0;
      int xPoints[]= {x1,x2,x2,x1};
      int yPoints[] = {y0,y0,y,y};

      for(i=0; i<N; i++){

         x1=i*dx+x0; x2=(i+1)*dx+x0 -2;
         y=y0-(int)((Double)hist2.get(i)*N/maxY*dy);
         xPoints[0]=x1; xPoints[1]=x2; xPoints[2]=x2; xPoints[3]=x1; yPoints[0]=y0; yPoints[1]=y0; yPoints[2]=y; yPoints[3]=y;

         g.setColor(COLOR1);
         g.fillPolygon(xPoints,yPoints,4);

         yPoints[0]=y; yPoints[1]=y;
         y=y0-(int)(((Double)hist1.get(i)+(Double)hist2.get(i))*N/maxY*dy); yPoints[2]=y; yPoints[3]=y;
         g.setColor(COLOR2);
         g.fillPolygon(xPoints,yPoints,4);

         yPoints[0]=y; yPoints[1]=y;
         y=y0-(int)(((Double)hist1.get(i)+(Double)hist2.get(i)+(Double)hist3.get(i))*N/maxY*dy); yPoints[2]=y; yPoints[3]=y;
         g.setColor(COLOR3);
         g.fillPolygon(xPoints,yPoints,4);

         yPoints[0]=y; yPoints[1]=y;
         y=y0-(int)((Double)hist.get(i)*N/maxY*dy); yPoints[2]=y; yPoints[3]=y;
         g.setColor(COLOR4);
         g.fillPolygon(xPoints,yPoints,4);

         g.setColor(Color.GRAY);
         if(i%2==0)
         g.drawString(Double.toString((Double)xLabel.get(i)), x1, y0+d0/5); //xLabel
         //g.drawString(Integer.toString((Integer)yLabel.get(i)), x0-d0/5, y); //yLabel
      }
      g.drawString(Double.toString((Double)xLabel.get(N)), x1+dx, y0+d0/5); //xLabel
      //g.drawString((Integer.toString((Integer)yLabel.get(N))), x0-d0/5, y0-(int)((Double)hist.get(N)*dy)); //yLabel
      /*//Legend
      g.setFont(new Font("Tahoma", 0, 10));
      g.setColor(Color.DARK_GRAY);
      g.drawString("Resultant directions", x0+Dx-150, y0-Dy+d0);
      g.setColor(Color.BLUE);
      g.drawString("Difference directions", x0+Dx-150, y0-Dy+d0+15);
      g.setColor(Color.GRAY);
      g.drawString("Resultant circles", x0+Dx-150, y0-Dy+d0+30);
      g.setColor(Color.MAGENTA);
      g.drawString("Difference circles", x0+Dx-150, y0-Dy+d0+45);*/
      for(i=0; i<=5; i++){
          y = (int)(1d*maxY/5*i);
          g.drawString(Integer.toString(y), x0-d0/5,  (int)(y0 - y*Dy/maxY)); //yLabel
      }
    }

    public static void plotWoodcock(Graphics g, Dimension tam, Vector vdsFilt, Vector vdsAll){

      //INITIALIZE GRAPHIC
      int Dx = tam.width; int Dy = tam.height;  int d0 = 60; Dx=Dx-d0; Dy=Dy-d0;

      int D = Math.min(Dx, Dy); Dx=D; Dy=D; //equal axis

      int x0 = d0/2; int y0 = tam.height-d0/2; // sw corner

      g.setColor (Color.GRAY);
      g.drawLine(x0, y0, x0+Dx, y0); // axes
      g.drawLine(x0, y0 , x0, y0-Dy);

      g.setFont(new Font("Tahoma", 0, 10)); g.setColor(Color.DARK_GRAY);
      g.drawString("ln(S2/S3)", x0+Dx/3, y0+15); //xlabel
      g.drawString("ln(S1/S2)", x0-25, y0-Dy/2); //ylabel
      g.drawString("'Girdling'", x0+Dx-30, y0+15); //xlabel
      g.drawString("'Clustering'", x0-15, y0-Dy-15); //ylabel

      //DATA
      int i; Vector vds, vds_pos, bingham; double d3, d2, d1;
      double xRV,yRV,xDV,yDV,xRP,yRP,xDP,yDP,xxRV,yyRV,xxDV,yyDV,xxRP,yyRP,xxDP,yyDP, xmax1,xmax2,xmax,ymax1,ymax2,ymax,max;

      //ALL DATA, WITHOUT FILTERING
      vds = VirtualDirections.getRV(vdsAll); //Resultant directions;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
          vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yyRV=Math.log(d1/d2); xxRV=Math.log(d2/d3);
      vds = VirtualDirections.getDV(vdsAll); //Difference directions;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
          vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yyDV=Math.log(d1/d2); xxDV=Math.log(d2/d3);
      vds = VirtualDirections.getRP(vdsAll); //Resultant circles;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
        vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yyRP=Math.log(d1/d2); xxRP=Math.log(d2/d3);
      vds = VirtualDirections.getDP(vdsAll); //Difference circles;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
          vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yyDP=Math.log(d1/d2); xxDP=Math.log(d2/d3);

      //FILTERED DATA
      vds = VirtualDirections.getRV(vdsFilt); //Resultant directions;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
          vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yRV=Math.log(d1/d2); xRV=Math.log(d2/d3);
      vds = VirtualDirections.getDV(vdsFilt); //Difference directions;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
          vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yDV=Math.log(d1/d2); xDV=Math.log(d2/d3);
      vds = VirtualDirections.getRP(vdsFilt); //Resultant circles;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
        vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yRP=Math.log(d1/d2); xRP=Math.log(d2/d3);
      vds = VirtualDirections.getDP(vdsFilt); //Difference circles;
      vds_pos=new Vector();
      for(i=0; i<vds.size(); i++)
          vds_pos.add(((VD)vds.get(i)).getPos());
      bingham = Statistics.bingham(vds_pos);
      d1=(Double)bingham.get(2);d2=(Double)bingham.get(1);d3=(Double)bingham.get(0);
      yDP=Math.log(d1/d2); xDP=Math.log(d2/d3);
      //System.out.println("xRV: "+xRV+", yRV: "+yRV+", xDV: "+xRV+", yDV: "+yRV+", xRP: "+xRP+", yRP: "+yRP+", xDP: "+xDP+", yDP: "+yDP);

      xmax1=Math.max(Math.max(xRV,xDV),Math.max(xRP,xDP)); ymax1=Math.max(Math.max(yRV,yDV),Math.max(yRP,yDP));
      xmax2=Math.max(Math.max(xxRV,xxDV),Math.max(xxRP,xxDP)); ymax2=Math.max(Math.max(yyRV,yyDV),Math.max(yyRP,yyDP));
      xmax=Math.max(xmax1,xmax2); ymax=Math.max(ymax1,ymax2);
      
      max=Math.max(xmax,ymax); xmax=max; ymax=max; //equal axis

      //PLOT GRAPHIC
      int posx, posy, w = Math.min(Dx, Dy)/40;

      g.setColor(COLOR1);
      posx=x0+(int)(xRV/xmax*Dx);
      posy=y0-(int)(yRV/ymax*Dy);
      g.fillOval(posx, posy-w/2, w, w);
      posx=x0+(int)(xxRV/xmax*Dx);
      posy=y0-(int)(yyRV/ymax*Dy);
      g.drawOval(posx, posy-w/2, w, w);
      g.setColor(COLOR2);
      posx=x0+(int)(xDV/xmax*Dx);
      posy=y0-(int)(yDV/ymax*Dy);
      g.fillOval(posx, posy-w/2, w, w);
      posx=x0+(int)(xxDV/xmax*Dx);
      posy=y0-(int)(yyDV/ymax*Dy);
      g.drawOval(posx, posy-w/2, w, w);
      g.setColor(COLOR3);
      posx=x0+(int)(xRP/xmax*Dx);
      posy=y0-(int)(yRP/ymax*Dy);
      g.fillOval(posx, posy-w/2, w, w);
      posx=x0+(int)(xxRP/xmax*Dx);
      posy=y0-(int)(yyRP/ymax*Dy);
      g.drawOval(posx, posy-w/2, w, w);
      g.setColor(COLOR4);
      posx=x0+(int)(xDP/xmax*Dx);
      posy=y0-(int)(yDP/ymax*Dy);
      g.fillOval(posx, posy-w/2, w, w);
      posx=x0+(int)(xxDP/xmax*Dx);
      posy=y0-(int)(yyDP/ymax*Dy);
      g.drawOval(posx, posy-w/2, w, w);


     
      g.setColor(Color.GRAY); //Line of shpe param. k=1
      posx=x0+(int)(Math.min(xmax, ymax)/xmax*Dx);
      posy=y0-(int)(Math.min(xmax, ymax)/ymax*Dy);
      g.drawLine(x0, y0, posx, posy);
      
      xmax=Math.round(xmax*100)/100d; ymax=Math.round(ymax*100)/100d;
      g.drawString(Double.toString(xmax),x0+Dx,y0);
      g.drawString(Double.toString(ymax),x0-15,y0-Dy);
      //Legend
      /*g.setColor(Color.DARK_GRAY);
      g.drawString("Resultant directions", x0+Dx-100, y0-Dy);
      g.setColor(Color.BLUE);
      g.drawString("Difference directions", x0+Dx-100, y0-Dy+15);
      g.setColor(Color.GRAY);
      g.drawString("Resultant circles", x0+Dx-100, y0-Dy+30);
      g.setColor(Color.MAGENTA);
      g.drawString("Difference circles", x0+Dx-100, y0-Dy+45);*/
      g.setColor(Color.BLACK);
      g.drawOval(x0+Dx-40, y0-Dy-15-w, w, w);
      g.fillOval(x0+Dx-40, y0-Dy-w, w, w);
      g.drawString("All", x0+Dx-25, y0-Dy-15);
      g.drawString("Filtered", x0+Dx-25, y0-Dy);

    }

    private void counterAll(){
        int RV=0, DV=0, RC=0, DC=0; VD vd;
        for(int j=0; j<vds_all.size(); j++){
            vd = (VD)vds_all.get(j);
            if( vd.getResDif().equals(RESULTANT) && vd.getPlaneLine().equals(VECTOR)){
                RV++;}
            if( vd.getResDif().equals(DIFFERENCE) && vd.getPlaneLine().equals(VECTOR)){
                DV++;}
            if( vd.getResDif().equals(RESULTANT) && vd.getPlaneLine().equals(PLANE)){
                RC++;}
           if( vd.getResDif().equals(DIFFERENCE) && vd.getPlaneLine().equals(PLANE)){
                DC++;}
        }
        RVTotalCounter.setText(Integer.toString(RV));
        DVTotalCounter.setText(Integer.toString(DV));
        RCTotalCounter.setText(Integer.toString(RC));
        DCTotalCounter.setText(Integer.toString(DC));
    }
    private void counter(){
        int RV=0, DV=0, RC=0, DC=0; VD vd;
        for(int j=0; j<vds_filt.size(); j++){
            vd = (VD)vds_filt.get(j);
            if( vd.getResDif().equals(RESULTANT) && vd.getPlaneLine().equals(VECTOR)){
                RV++;}
            if( vd.getResDif().equals(DIFFERENCE) && vd.getPlaneLine().equals(VECTOR)){
                DV++;}
            if( vd.getResDif().equals(RESULTANT) && vd.getPlaneLine().equals(PLANE)){
                RC++;}
           if( vd.getResDif().equals(DIFFERENCE) && vd.getPlaneLine().equals(PLANE)){
                DC++;}
        }
        RVCounter.setText(Integer.toString(RV));
        DVCounter.setText(Integer.toString(DV));
        RCCounter.setText(Integer.toString(RC));
        DCCounter.setText(Integer.toString(DC));
    }

    private void save(){
        JFileChooser chooser = new JFileChooser();
        chooser.changeToParentDirectory();
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            String fileName = chooser.getSelectedFile().getPath();
            new saveEps(fileName + ".eps", vdView, vds_filt, vds_all);
        }
    }
        

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField DCCounter;
    private javax.swing.JTextField DCTotalCounter;
    private javax.swing.JTextField DVCounter;
    private javax.swing.JTextField DVTotalCounter;
    private javax.swing.JTextField RCCounter;
    private javax.swing.JTextField RCTotalCounter;
    private javax.swing.JTextField RVCounter;
    private javax.swing.JTextField RVTotalCounter;
    private javax.swing.JPanel counterPanel;
    private javax.swing.JPanel intensityPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel logoPanel;
    private javax.swing.JPanel madPanel;
    private javax.swing.JTextField maxIntInput;
    private javax.swing.JTextField maxMadInput;
    private javax.swing.JTextField minIntInput;
    private javax.swing.JTextField minMadInput;
    private javax.swing.JTextField numStepsInput;
    private javax.swing.JButton okButton;
    private javax.swing.JButton refreshButton;
    private javax.swing.JButton saveButton;
    private javax.swing.JTextField stepEndInput;
    private javax.swing.JTextField stepIniInput;
    private javax.swing.JPanel stepsPanel;
    private javax.swing.JPanel woodcocksPanel;
    // End of variables declaration//GEN-END:variables
    
}
