package paldirvd;


import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.Collection;
import java.util.HashMap;
import java.util.Vector;

/***/

public class ImportExport {
     
    private static String FINAL_FILE = "\"END\"";
    private static String FINAL_PARAGRAPH = "9999";

    private static String LINE="V", PLANE="P", DIRECTION="VD", CIRLCE="VC", TC="TC", NOTC="NO TC";
    //Read .th file and save data into an array of core type
    static Vector readUtrech(String fileName){
    
        Vector cores = new Vector();
        String line;
        int i;
        boolean jump_line = false, go = true;
        double temperature = 0, x = 0, y = 0, z = 0, dec, inc, intensity, error = 0;
        
        try{
          
            FileReader fileReader = new FileReader(fileName);
            BufferedReader buffer = new BufferedReader(fileReader);
            System.out.println("file: " + fileName);

            buffer.readLine(); //Site name
                
                line = buffer.readLine(); //Core name, core comment, trend, plunge, volume, strike, dip

                //System.out.println("Core name, core comment, trend, plunge, volume, strike, dip: " + line);

                while(!line.contains(FINAL_FILE)){

                    i = line.indexOf(",");
                    String name = line.substring(0, i);

                    line = line.substring(i + 1);
                    i = line.indexOf(",");
                    String comment = line.substring(0, i);

                    line = line.substring(i + 1);
                    i = line.indexOf(",");
                    int trend = Integer.valueOf(line.substring(0, i));

                    line = line.substring(i + 1);
                    i = line.indexOf(",");
                    int plunge = Integer.valueOf(line.substring(0, i));

                    line = line.substring(i + 1);
                    i = line.indexOf(",");
                    double volume = Double.valueOf(line.substring(0, i));

                    line = line.substring(i + 1);
                    i = line.indexOf(",");
                    int strike = Integer.valueOf(line.substring(0, i));

                    int dip = Integer.valueOf(line.substring(i + 1));

                    Core core = new Core(name, comment, trend, plunge, strike, dip, volume);

                    line = buffer.readLine();
                    
                    int num_line = 0; go = true;
                    while(!line.trim().equals(FINAL_PARAGRAPH)){ //temperature, position, error

                        //System.out.println("Step, x, y, z, error: " + line);

                        jump_line = false; num_line = num_line + 1;
                        
                        i = line.indexOf(",");
                        temperature = Double.valueOf(line.substring(0, i));

                        if(temperature == 0 && num_line > 1)
                            jump_line = true;
    
                        if(!jump_line){        
 
                        line = line.substring(i + 1);
                        i = line.indexOf(",");
                        x = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(",");
                        y = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(",");
                        z = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(",");
                        error = Double.valueOf(line.substring(0, i));

                        Position position = new Position(x, y, z, error);
                        Step stepN = new Step(temperature, position);
                        core.setStepN(stepN);
                        
                        }
                       
                        line = buffer.readLine();
                           
                        }
                    cores.add(core);
                    
                    line = buffer.readLine();
            }
            buffer.close();

        }catch (IOException ex) {System.out.println(ex);
        }catch(NumberFormatException e){System.out.println(e);}
        
        //System.out.println("Num muestras: " + cores.size());
        return cores;
    }

    static Vector readRoma(String fileName){

        Vector cores = new Vector();
        int i;
        String line;
        String name, az;
        int trend, plunge, strike, dip;
        double aux, temperature, x, y, z, dec, inc, intensity, err_x, err_y, err_z, error;
        Position position; Step stepN; Core core;
        HashMap coreList = new HashMap();

        try{
            FileReader fileReader = new FileReader(fileName);
            BufferedReader buffer = new BufferedReader(fileReader);
            System.out.println("file: " + fileName);

            System.out.println("Archivo G2 Romag");
            buffer.readLine(); //Heading
            //Sample_ID (name), AF_Z (az), X_intensity (x), Y_intensity (y), Z_intensity (z), Sample_Azimiuth (trend), Sample_Dip (plunge), Formation_Dip_Azimuth (strike-90), Formation_Dip (dip), Declination:_Unrotated (dec), Inclination:_Unrotated (inc), Intensity (intensity), X_mean (err_x), Y_mean (err_y), Z_mean (err_z), X_drift, Y_drift, Z_drift, Temp_C (temperature)
            line = buffer.readLine();

            while(line != null){

                i = line.indexOf("\t");
                name = line.substring(0, i);
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                az = line.substring(0, i);
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                x = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                y = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                z = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                aux = Double.valueOf(line.substring(0, i));
                trend = (int)aux;
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                aux = Double.valueOf(line.substring(0, i));
                plunge = (int)aux;
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                aux = Double.valueOf(line.substring(0, i));
                strike = (int)aux - 90;
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                aux = Double.valueOf(line.substring(0, i));
                dip = (int)aux; 
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                dec = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                inc = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                intensity = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                //i = line.indexOf("\t"); line = line.substring(i + 1); i = line.indexOf("\t"); line = line.substring(i + 1); i = line.indexOf("\t"); line = line.substring(i + 1);
                i = line.indexOf("\t");
                err_x = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                err_y = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t");
                err_z = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 1);

                i = line.indexOf("\t"); line = line.substring(i + 1); i = line.indexOf("\t"); line = line.substring(i + 1); i = line.indexOf("\t"); line = line.substring(i + 1);
                temperature = Double.valueOf(line);

                line = buffer.readLine();

                //error = Math.sqrt(err_x*err_x+err_y*err_y+err_z*err_z)/Math.sqrt(x*x+y*y+z*z); //Standar error ¿¿¿¿¿ESTO ES ASI?????
                x=x*1E6; y=y*1E6; z=z*1E6; intensity=intensity*1E6; // Intensity *1E-6
                //position = new Position(-z, -x, y, error); // Be careful with axis orientation -z=a, -x=b, y=c
                position = new Position(dec,inc,0);
                position.setInt(intensity);

                stepN = new Step(temperature, position);

                if (coreList.containsKey(name)){
                    core = (Core) coreList.get(name);
                    core.setStepN(stepN);
                    coreList.put(name, core);
                }else{
                    core = new Core(name, "az " + az, trend, plunge, strike, dip, 0);
                    core.setStepN(stepN);
                    coreList.put(name, core);
                }

            }

            Collection coresCollection = coreList.values();
            cores = new Vector(coresCollection);

        }catch (IOException ex) {System.out.println(ex);
        }catch (NumberFormatException e) {System.out.println(e);}

        return cores;
    }

     static Vector readMichigan(String fileName){

        Vector cores = new Vector();
        String line;
        int i;
        double aux, temperature, x, y, z, dec, inc, intensity;
        Position position; Step stepN;

        try{

            FileReader fileReader = new FileReader(fileName);
            BufferedReader buffer = new BufferedReader(fileReader);
            System.out.println("file: " + fileName);

                line = buffer.readLine(); //Core name, trend, plunge, strike, dip, volume

                line= line.replaceAll(" \\s+", " "); //Reemplazo los multiples espacios por uno solo
                //System.out.println(line);

                i = line.indexOf(" ");
                String name = line.substring(0, i);

                line = line.substring(i + 1);
                i = line.indexOf(" ");
                aux = Double.valueOf(line.substring(0, i));
                int trend = (int) aux;

                line = line.substring(i + 1);
                i = line.indexOf(" ");
                aux = Double.valueOf(line.substring(0, i));
                int plunge = (int) aux;

                line = line.substring(i + 1);
                i = line.indexOf(" ");
                aux = Double.valueOf(line.substring(0, i));
                int strike = (int)aux;

                line = line.substring(i + 1);
                i = line.indexOf(" ");
                aux = Double.valueOf(line.substring(0, i));
                int dip = (int)aux;

                line = line.substring(i + 1);
                i = line.indexOf(" ");
                double volume = Double.valueOf(line.substring(0, i));

                Core core = new Core(name, "", trend, plunge, strike, dip, volume);

                System.out.println("Name: "+ name+", trend: "+trend+", plunge: "+plunge+", strike: "+strike+", dip: "+dip);

                line = buffer.readLine();

                while(line != null){ //temperature, intensity, x, y, z, dec, inc

                        line= line.replaceAll(" \\s+", " "); //Reemplazo los multiples espacios por uno solo
                        //System.out.println(line);

                        i = line.indexOf(" "); line = line.substring(i + 1); i = line.indexOf(" ");
                        temperature = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(" ");
                        intensity = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(" ");
                        x = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(" ");
                        y = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(" ");
                        z = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(" ");
                        dec = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf(" ");
                        inc = Double.valueOf(line.substring(0, i));

                        //position = new Position(x, y, z, 0); //Tal vez no sea ninguna de las dos opciones de xyz...
                        //position = new Position(-z, -x, y, 0);
                        position = new Position(dec,inc,0);
                        position.setInt(intensity*1E3);
                        stepN = new Step(temperature, position);
                        core.setStepN(stepN);
                        
                        //System.out.println("Temp: "+temperature+", x: "+x+", y: "+y+", z: "+z+", int: "+intensity+", dec: "+dec+", inc: "+inc+", intenstity: "+position.getInt()+", declination: "+position.getDec()+", inclination: "+position.getInc());
                        System.out.println("Temp: "+temperature+", x: "+x+", y: "+y+", z: "+z+", int: "+intensity+", dec: "+dec+", inc: "+inc+", X: "+position.getX()+", Y: "+position.getY()+", Z: "+position.getZ());

                        line = buffer.readLine();

                   }
            cores.add(core);
            buffer.close();

        }catch (IOException ex) {System.out.println(ex);
        }catch(NumberFormatException e){System.out.println(e);}

        return cores;
    }
    static Vector readUchannels(String fileName){

        Vector cores = new Vector();
        String line;
        int i;
        double temperature = 0, x = 0, y = 0, z = 0;

        try{
            FileReader fileReader = new FileReader(fileName);
            BufferedReader buffer = new BufferedReader(fileReader);
            System.out.println("file: " + fileName);

            buffer.readLine(); //Heading
            line = buffer.readLine();   //Depth, step, x, y, z, dec, inc, int
            System.out.println("Archivo de sondeos");
            int n=1;
            try{
                i = line.indexOf("\t");
                String depth = line.substring(0, i);

                while(line != null){

                    String depth_ant = depth;
                    Core core = new Core(depth, "", 0, 0, 0, 0, 0);

                    while(depth.equals(depth_ant)){ //temperature, position, error

                        //x, y, z: South, East, Down
                        //We change it as in paldir format a, b, c: Up, North, East

                        line = line.substring(i + 1);
                        i = line.indexOf("\t");
                        temperature = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf("\t");
                        x = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf("\t");
                        y = Double.valueOf(line.substring(0, i));

                        line = line.substring(i + 1);
                        i = line.indexOf("\t");
                        z = Double.valueOf(line.substring(0, i));

                        x=x*1E6; y=y*1E6; z=z*1E6;
                        Position position = new Position(-z, -x, y, 0);

                        Step stepN = new Step(temperature, position);
                        core.setStepN(stepN);

                        //System.out.println("Depth: " + depth + ", step: " + temperature + ", x: " + x + ", y: " + y + ", z: " + z + ", dec: " + position.getDec() + ", inc: " + position.getInc() + ", int: " + position.getInt());

                        line = buffer.readLine();
                        i = line.indexOf("\t");
                        depth = line.substring(0, i);
                    }
                    cores.add(core);
                    n = n + 1;
                }
            }catch(NullPointerException e){System.out.println("Lineas: " + n +". Fin del archivo");}

          buffer.close();

        }catch (IOException ex) {System.out.println(ex);
        }catch(NumberFormatException e){System.out.println(e);}

        return cores;
    }

    static Vector readVD(String fileName){
    
        Vector vds = new Vector();
        String line;
        VD vd;
        String nameCore, resDif, planeLine;
        int stepIni, stepEnd, numSteps;
        Position pos;
        double dec, inc, err;
        int i;
        
        try{
            FileReader fileReader = new FileReader(fileName);
            BufferedReader buffer = new BufferedReader(fileReader);
            
            // Resultant/Diference, Plane/Line, StepIni, StepEnd, NumSteps, Declination, Inclination, Error
            //line = buffer.readLine(); //first line = heading;
            line = buffer.readLine();
            while(!line.contains(FINAL_FILE)){
                i = line.indexOf(",");
                nameCore = line.substring(i, i);
                line = line.substring(i + 2);
                
                i = line.indexOf(",");
                resDif = line.substring(0, i);
                line = line.substring(i + 2);
                
                i = line.indexOf(",");
                planeLine = line.substring(0, i); if (planeLine.equals(DIRECTION)) planeLine=LINE; else planeLine=PLANE;
                line = line.substring(i + 2);
                
                i = line.indexOf(",");
                stepIni = Integer.valueOf(line.substring(0, i));
                line = line.substring(i + 2);
                
                i = line.indexOf(",");
                stepEnd = Integer.valueOf(line.substring(0, i));
                line = line.substring(i + 2);
                
                i = line.indexOf(",");
                numSteps = Integer.valueOf(line.substring(0, i));
                line = line.substring(i + 2);
                
                i = line.indexOf(",");
                dec = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 2);
                
                i = line.indexOf(",");
                inc = Double.valueOf(line.substring(0, i));
                line = line.substring(i + 2);
                
                err = Double.valueOf(line.substring(0, i));
                    
                pos = new Position(dec,inc,err);
                vd = new VD(nameCore, resDif, planeLine, stepIni, stepEnd, numSteps, pos, null);
                vds.add(vd);
                
                line = buffer.readLine(); 
            }         
            buffer.close();

        }catch (IOException ex) {System.out.println(ex);}
    
        return vds;
    }
 
    static void writeSite(String fileName, Vector site){
        try{
            fileName=fileName+".th";
            FileWriter fileWriter = new FileWriter(fileName);
            PrintWriter outputStream  = new PrintWriter(fileWriter);
            String line, name;
            Core core; Vector steps; Step step; Position pos;
            
            outputStream.println("\" " + fileName + " \",\" \"");
            for(int i=0; i<site.size(); i++){
                core = (Core)site.get(i);

                name = core.getName(); name=name.replace(",",".");
                line = "\""+name +"\","+ "\" "+core.getComment()+"\"," + core.getTrend() + "," +  core.getPlunge() + "," +
                       core.getVol() + "," + core.getStrike() + "," + core.getDip();
                outputStream.println(line);
  
                steps = core.getSteps();
                for(int j=0; j<steps.size(); j++){
                    step = (Step)steps.get(j);
                    pos = step.getPos();
                    pos.round4();
                    line = step.getTemp() + "," + pos.getX() + "," + pos.getY() + "," + pos.getZ() + "," +
                           pos.getError() + ",\" \",\" \"";
                    outputStream.println(line);
                }
                outputStream.println(FINAL_PARAGRAPH);
            }            
            outputStream.println(FINAL_FILE );
            outputStream.close();
        }catch (IOException ex) {System.out.println("Error writeSite");}
    }
    
    static void writeVD(String fileName, Vector vds, boolean tc, boolean append){
       
        try{
            fileName=fileName+".txt";
            FileWriter fileWriter = new FileWriter(fileName, append);
            PrintWriter outputStream  = new PrintWriter(fileWriter);
            String line;
            VD vd;

            if(tc) line = "TC"; else line = "NO TC";
            outputStream.println(line);
            line ="Sample, Resultant/Difference, Direction/Circle, stepMIN, stepMAX, #steps, DEC, INC, INT, MAD";
            outputStream.println(line);
            for(int i=0; i<vds.size(); i++){
                vd = (VD)vds.get(i);
                Position pos = vd.getPos();
                pos.round4();
                line = vd.getNameCore() + ", " + 
                       vd.getResDif() + ", " + vd.getPlaneLine2() + ", " +
                       vd.getStepIni() + ", " + vd.getStepEnd() + ", " + vd.getNumSteps() + ", " +
                       pos.getDec() + ", " + pos.getInc() + ", " + pos.getInt() + ", " + pos.getError();

                /*line = vd.getNameCore() + ", " +
                       vd.getResDif() + ", " + vd.getPlaneLine() + ", " + 
                       vd.getStepIni() + ", " + vd.getStepEnd() + ", " + vd.getNumSteps() + ", " +
                       Math.round(vd.getPos().getDec()) + ", " + Math.round(vd.getPos().getInc()) + ", " +
                       //Math.round(vd.getPos().getInt()) + ", " +
                       (double)Math.round(vd.getPos().getError()*1000)/1000d + "\n";*/

                outputStream.println(line);
            }
            if(!append)
                outputStream.println(FINAL_FILE);
            outputStream.close();
        }catch (IOException ex) {System.out.println("Error writeVD");}
    }

     static void writeStatistics(String fileName, Vector vds, boolean tc){

        String line; Vector v;
        try{
            fileName=fileName+".txt";
            FileWriter fileWriter = new FileWriter(fileName);
            PrintWriter outputStream  = new PrintWriter(fileWriter);

            line ="VD STATISTICS, ";
            if(tc) line = line + "TC\n"; else line = line + "NO TC\n";
            outputStream.println(line);

            line ="Resultant Virtual Directions\n";
            outputStream.println(line);
            v = VirtualDirections.getRV(vds);
            outputStream = calculateStatistics(outputStream,  v, true);


            line ="Difference Virtual Directions\n";
            outputStream.println(line);
            v = VirtualDirections.getDV(vds);
            outputStream = calculateStatistics(outputStream,  v, true);

            line ="Resultant Virtual Circles\n";
            outputStream.println(line);
            v = VirtualDirections.getRP(vds);
            outputStream = calculateStatistics(outputStream,  v, false);

            line ="Difference Virtual Circles\n";
            outputStream.println(line);
            v = VirtualDirections.getDP(vds);
            outputStream = calculateStatistics(outputStream,  v, false);

        outputStream.close();
        }catch (IOException ex) {System.out.println("Error writeVD");}
    }

private static PrintWriter calculateStatistics(PrintWriter outputStream, Vector v, Boolean fisher){

          String line; Vector vpos = new Vector(), fishmean, bingham; Position pos;

          for(int i=0; i<v.size(); i++){
             vpos.add(((VD)v.get(i)).getPos());
          }

          if(fisher){ //Only for directions, not for planes
          //Fisher
          line = "Fisher mean: dec, inc, k, a95, n";
          outputStream.println(line);
          fishmean = Statistics.fisherMean(vpos);
          //Positive inclination
          pos = (Position)(fishmean).get(1);
          pos.round();
          line = "Pos: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(6) + ", " + fishmean.get(7) + " , " + fishmean.get(8);
          outputStream.println(line);
          //Negative inclination
          pos = (Position)(fishmean).get(2);
          pos.round();
          line = "Neg: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(9) + ", " + fishmean.get(10) + " , " + fishmean.get(11);
          outputStream.println(line);
          //Positive + negative rotated
          pos = (Position)(fishmean).get(3);
          pos.round();
          line = "Pos+ Neg-: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(12) + ", " + fishmean.get(13) + " , " + fishmean.get(14);
          outputStream.println(line);
          /*//All together: positive + negative
          pos = (Position)(fishmean).get(0);
          pos.round();
          line = "All: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(4) + ", " + fishmean.get(5) + " , " + fishmean.get(14);
          outputStream.println(line);*/
          }

          //Bingham
          line = "Bingham: e, dec, inc";
          outputStream.println(line);
          bingham = Statistics.bingham(vpos);
          int j=1;
          for(int i=5; i>2; i--){
             pos = (Position)bingham.get(i);
             pos.round();
             line = "(" + j + ") " + bingham.get(i-3) + ", " + (int)pos.getDec() + ", " + (int)pos.getInc();
             outputStream.println(line);
             j++;
          }

          return outputStream;
}

static Vector readG2(String fileName){
    Core core = null;

     try{

            FileInputStream fileInput = new FileInputStream(fileName);
            StringBuffer buffer = new StringBuffer();
            InputStreamReader isr = new InputStreamReader(fileInput,"UTF8");
            Reader in = new BufferedReader(isr);
            int ch;
            while ((ch = in.read()) > -1) {
                if (ch<=31 || ch>=127)
                    if (ch==0)
                        buffer.append(' ');
                    else
                        buffer.append(',');
                else
                    buffer.append((char)ch);
            }
            in.close(); isr.close();
            String text = buffer.toString();
//System.out.println("TEXTO INICIAL: "+text);
            text= text.replaceAll(", , ,", ",");
            text= text.replaceAll(" \\s+", " ");
            text= text.replaceAll(" - ", "");

//System.out.println("TEXTO SIN COMAS NI ESPACIOS: "+text);
            String text2;
            int i;
            String temperature, declination, inclination, xInt, yInt, zInt, xErr, yErr, zErr;
            Position pos; Step stepN;
            double dec, inc, x, y, z, err_x, err_y, err_z, error, temp;

            i = text.indexOf(","); text = text.substring(i + 2); i = text.indexOf(","); text = text.substring(i + 2); i = text.indexOf(","); text = text.substring(i + 2);
            i = text.indexOf(" ");
            String name = text.substring(0, i); //Sample Name
            text = text.substring(i);

            i = text.indexOf(",");
            text2 = text.substring(0,i-1);
            text = text.substring(i+2);
            i = text2.lastIndexOf(" ");
            String vol = text2.substring(i+1); //Volume

            i = text.indexOf(",");
            text2 = text.substring(0,i-1);
            i = text2.lastIndexOf(" "); text2 = text2.substring(0,i); i=text2.lastIndexOf(" "); text2 = text2.substring(0,i); i=text2.lastIndexOf(" "); text2 = text2.substring(0,i); // Present Declination Correction +  Fold Plunge + Fold Trend

            i = text2.lastIndexOf(" ");
            String dip = text2.substring(i+1); //S0 - dip
            text2 = text2.substring(0,i);

            i = text2.lastIndexOf(" ");
            String dipDirection = text2.substring(i+1); //S0 - dipDirection = strike - 90
            text2 = text2.substring(0,i);

            i = text2.lastIndexOf(" ");
            String plunge = text2.substring(i+1); //Drilling (core orientation)- plunge
            text2 = text2.substring(0,i);

            i = text2.lastIndexOf(" ");
            String trend = text2.substring(i+1); //Drilling (core orientation)- trend
            text2 = text2.substring(0,i);

            System.out.println("Name: "+name+", Volume: "+vol+", Trend: "+trend+", Plunge: "+plunge+", DipDirection: "+dipDirection+", Dip: "+dip);

            core = new Core(name, "", Integer.parseInt(trend), Integer.parseInt(plunge), Integer.parseInt(dipDirection)-90, Integer.parseInt(dip), Double.valueOf(vol));

            i = text.indexOf(","); text = text.substring(i + 2); i = text.indexOf(","); text = text.substring(i + 2);

            while (text.length()>1 && i!=-1){

            //Number + Demagnetization level + Dec + Inc + Dec (core correction) + Inc (core correction) + Dec (S0 correction) + Inc (S0 correction) + M (moment emu) + J (moment cc-1) + X intensity (emu/cc) + SX (standar deviation) + NX (number of measurements) + EX (error) + Y + SY + NY + EY + Z + SZ + NZ + EZ + S/N (ratio signal/noise) + S/D (ratio signal/drift) + S/H (ratio signal/holder)

            i = text.indexOf(" ");
            temperature = text.substring(0,i-1); if (temperature.contains("NR")) temperature="000"; //NaturalRemanentMagnetization = Present field
            text = text.substring(i + 1);

            i = text.indexOf(" ");
            declination = text.substring(0,i);
            text = text.substring(i + 1);

            i = text.indexOf(" ");
            inclination = text.substring(0,i);
            text = text.substring(i + 1);

            for(int j=0; j<6; j++){
                i = text.indexOf(" "); text = text.substring(i + 1);}

            i = text.indexOf(" ");
            xInt = text.substring(0,i); //Intensity 
            text = text.substring(i + 1);

            i = text.indexOf(" ");
            xErr = text.substring(0,i); //Standar deviation. Measurement error
            text = text.substring(i + 1);
            
            i = text.indexOf(" "); text = text.substring(i + 1);i = text.indexOf(" "); text = text.substring(i + 1);

            i = text.indexOf(" ");
            yInt = text.substring(0,i);
            text = text.substring(i + 1);

            i = text.indexOf(" ");
            yErr = text.substring(0,i);
            text = text.substring(i + 1);

            i = text.indexOf(" "); text = text.substring(i + 1);i = text.indexOf(" "); text = text.substring(i + 1);

            i = text.indexOf(" ");
            zInt = text.substring(0,i);
            text = text.substring(i + 1);

            i = text.indexOf(" ");
            zErr = text.substring(0,i);
            text = text.substring(i + 1);

            i = text.indexOf(" "); text = text.substring(i + 1);i = text.indexOf(" "); text = text.substring(i + 1);

            i = text.indexOf(","); text = text.substring(i + 2); i = text.indexOf(","); text = text.substring(i + 2);

            System.out.println("Temperature: "+temperature+", Declination: "+declination+", Inclination: "+inclination+", xInt: "+xInt+", xErr: "+xErr+", yInt: "+yInt+", yErr: "+yErr+", zInt: "+zInt+", zErr: "+zErr);

            temp=Double.valueOf(temperature);
            dec=Double.valueOf(declination); inc=Double.valueOf(inclination);
            x=Double.valueOf(xInt); y=Double.valueOf(yInt); z=Double.valueOf(zInt);
            err_x=Double.valueOf(xErr); err_y=Double.valueOf(yErr); err_z=Double.valueOf(zErr);
            error=Math.sqrt((err_x*err_x+err_y*err_y+err_z*err_z)/(x*x+y*y+z*z))*100; //calculated from the standar deviation

            pos = new Position(dec,inc, error); // Axis orientation: A,B,C = -Z,-X,Y
            x=x*1E6; y=y*1E6; z=z*1E6; // 10E-6A/m
            //1emu=10E-3A*m2, 1cc=1cm3, 1emu/cc = 10E3A/m = 10E9*10E-6A/m
            pos.setInt(Math.sqrt(x*x+y*y+z*z));
            stepN = new Step(temp, pos);
            core.setStepN(stepN);

            }

        }catch (IOException ex) {System.out.println(ex);}

    Vector v = new Vector(); v.add(core);
    return v;
}


}