/*
 * MainWindow.java
 */

package paldirvd;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.Arc2D;
import java.io.File;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class MainWindow extends javax.swing.JFrame {

    private static String UTRECH="UTRECH", G2="G2", ROMA="ROMA", UCHANNELS="U-CHANNELS", MICHIGAN="MICHIGAN";
    private String name = "NAME";
    private boolean tc = false;
    private boolean upNorth = false;
    private boolean stacking = false;
    private boolean af = false;
    private DefaultListModel siteListModel = new DefaultListModel();
    private DefaultListModel finalSiteListModel = new DefaultListModel();
    private DefaultListModel index = new DefaultListModel();
    private DefaultListModel finalIndex = new DefaultListModel();
    private Vector siteIni = new Vector(), site = new Vector();
    private Core stackingCore;
    private Vector insertedSteps = new Vector(), validStepsStaking = new Vector();
    private Position actualPos = null;
    private boolean focusCoreList=true, focusSiteList=false, focusFinalSiteList=false;
  
  
    /** Creates new form MainWindow */
    public MainWindow() {
        initComponents();
        coreName.setEditable(false);
        stepInfo.setEditable(false);
        //siteIni = Main.getSite();
        //siteIni = ImportExport.readUtrech("Canal3.txt");
        //site = Main.drillingCorrection(siteIni);
        //initSiteList();
        addWindowListener(new FrameListener());
        tc_ntc.addKeyListener(new ComponentListener());
        upN_upW.addKeyListener(new ComponentListener());
        stereoPlot.addKeyListener(new ComponentListener());
        ortogonalPlot.addKeyListener(new ComponentListener());
        intensityPanel.addKeyListener(new ComponentListener());
        Component com[] = corePanel.getComponents();
        for(int i=0; i<com.length; i++)
            com[i].addKeyListener(new ComponentListener());
        com = pcaPanel.getComponents();
        for(int i=0; i<com.length; i++)
            com[i].addKeyListener(new ComponentListener());
        com = sitePanel.getComponents();
        for(int i=0; i<com.length; i++)
            com[i].addKeyListener(new ComponentListener());
        coreList.addKeyListener(new ComponentListener());
        siteList.addKeyListener(new ComponentListener());
        finalSiteList.addKeyListener(new ComponentListener());
        pcaText.addKeyListener(new ComponentListener());
        stepInfo.addKeyListener(new ComponentListener());

 /*//CARGAMOS UN VECTOR DE PRUEBA
        Vector v = ImportExport.readUtrech("AR02b.txt");
        siteIni = v;    
        site = Main.drillingCorrection(siteIni);
        initSiteList(); */

        virtualButton.setEnabled(false);
        stackingButton.setEnabled(false);
        lsaButton.setEnabled(false);
        saveFinalSiteButton.setEnabled(false);
        
        this.setTitle("Paleomagnetic Directions");

        CreditsWindow iniPanel = new CreditsWindow();

   
    }
    
     class FrameListener extends WindowAdapter
    {
       public void windowClosing(WindowEvent e){

           setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);

           int exit = JOptionPane.showConfirmDialog(null,"Do  you want to exit the program?", "", JOptionPane.YES_NO_OPTION);
           if (exit == JOptionPane.YES_OPTION)              
               System.exit(0);

      }
    }   
    
     class ComponentListener extends KeyAdapter
     {
        public void keyPressed(KeyEvent e){

            if( e.getKeyChar()=='c'){
               System.out.println("Tecla c pulsada -> cambio de ventana, de core a site a final site");
                if(focusCoreList){
                    System.out.println("SITE LIST");
                    focusCoreList=false; focusSiteList=true;
                    siteList.requestFocus(true);
                }else{
                    if(focusSiteList){
                    System.out.println("FINAL SITE LIST");
                    focusSiteList=false; focusFinalSiteList=true;
                    finalSiteList.requestFocus(true);
                    }else{
                        if(focusFinalSiteList){
                            System.out.println("CORE LIST");
                            focusFinalSiteList=false; focusCoreList=true;
                            coreList.requestFocus(true);
                        }
                    }
                }
            }

           if (e.getKeyCode() == KeyEvent.VK_S){
	        if (e.isMetaDown()){
                	//System.out.println("Meta + s : save");
                        save();
                 }
           }
           
           if (e.getKeyCode() == KeyEvent.VK_O){
	        if (e.isMetaDown()){
                	//System.out.println("Meta + o : open");
                        open(UTRECH, false);
                 }
           }
           if (e.getKeyCode() == KeyEvent.VK_W){
	        if (e.isMetaDown()){
                	//System.out.println("Meta + w : close");
                        int exit = JOptionPane.showConfirmDialog(null,"Do  you want to exit the program?", "", JOptionPane.YES_NO_OPTION);
                        if (exit == JOptionPane.YES_OPTION)              
                               System.exit(0);
                }
           }
           if (e.getKeyCode() == KeyEvent.VK_F7){
               //System.out.println("F7: upNorth / upWest");
                        upNorth = !upNorth;
                        if (upNorth)
                            upN_upW.setText("UP/W");
                        else
                            upN_upW.setText("UP/N");
                        repaint();
           }
           if (e.getKeyCode() == KeyEvent.VK_F8){
               //System.out.println("F8: tc/no tc");
                       tc = !tc;
                        if (tc)
                            tc_ntc.setText("NO TC");
                        else
                            tc_ntc.setText("TC");
                        repaint();
           }
           if (e.getKeyCode() == KeyEvent.VK_F9){
               //System.out.println("F9: pca inclor");
               incCircAction();
               incDirAction();
               repaint();
           }
           if (e.getKeyCode() == KeyEvent.VK_F10){
               //System.out.println("F10: pca exclor");
               excCircAction();
               excDirAction();
               repaint();
           }
        }
 
     }
     
     
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        stereoPlot = new javax.swing.JPanel();
        label = new javax.swing.JLabel();
        ortogonalPlot = new javax.swing.JPanel();
        intensityPanel = new javax.swing.JPanel();
        errorPanel = new javax.swing.JPanel();
        upN_upW = new javax.swing.JButton();
        tc_ntc = new javax.swing.JButton();
        corePanel = new javax.swing.JPanel();
        stepName = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        stepInfo = new javax.swing.JTextPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        coreList = new javax.swing.JList();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        deleteStep = new javax.swing.JButton();
        insertStep = new javax.swing.JButton();
        jScrollPane6 = new javax.swing.JScrollPane();
        coreName = new javax.swing.JTextPane();
        pcaPanel = new javax.swing.JPanel();
        exportDirectionsButton = new javax.swing.JButton();
        clearPcaButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        incDirButton = new javax.swing.JButton();
        incCircButton = new javax.swing.JButton();
        excCircButton = new javax.swing.JButton();
        excDirButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane5 = new javax.swing.JScrollPane();
        pcaText = new javax.swing.JTextArea();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        exportGraphicsButton = new javax.swing.JButton();
        clearAllPcaButton = new javax.swing.JButton();
        sitePanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        finalSiteList = new javax.swing.JList();
        virtualButton = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        siteList = new javax.swing.JList();
        addButton = new javax.swing.JButton();
        addAllButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        removeAllButton = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        stackingButton = new javax.swing.JButton();
        saveFinalSiteButton = new javax.swing.JButton();
        lsaButton = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        actualField = new javax.swing.JButton();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        logoPanel = new javax.swing.JPanel();
        jMenuBar25 = new javax.swing.JMenuBar();
        fileMenu24 = new javax.swing.JMenu();
        utrechOpen = new javax.swing.JMenuItem();
        g2Open = new javax.swing.JMenuItem();
        romaOpen = new javax.swing.JMenuItem();
        michiganOpen = new javax.swing.JMenuItem();
        uchannelsOpen = new javax.swing.JMenuItem();
        utrechAppend = new javax.swing.JMenuItem();
        g2Append = new javax.swing.JMenuItem();
        romaAppend = new javax.swing.JMenuItem();
        michiganAppend = new javax.swing.JMenuItem();
        uchannelsAppend = new javax.swing.JMenuItem();
        fileExit = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        stereoPlot.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        stereoPlot.setMinimumSize(new java.awt.Dimension(200, 200));
        stereoPlot.setPreferredSize(new java.awt.Dimension(350, 350));
        stereoPlot.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        stereoPlot.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                dataPoint(evt, stereoPlot, label);
            }
        });

        org.jdesktop.layout.GroupLayout stereoPlotLayout = new org.jdesktop.layout.GroupLayout(stereoPlot);
        stereoPlot.setLayout(stereoPlotLayout);
        stereoPlotLayout.setHorizontalGroup(
            stereoPlotLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(stereoPlotLayout.createSequentialGroup()
                .add(label, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 158, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(174, Short.MAX_VALUE))
        );
        stereoPlotLayout.setVerticalGroup(
            stereoPlotLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, stereoPlotLayout.createSequentialGroup()
                .addContainerGap(305, Short.MAX_VALUE)
                .add(label, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 45, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(19, 19, 19))
        );

        ortogonalPlot.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        ortogonalPlot.setMinimumSize(new java.awt.Dimension(200, 200));
        ortogonalPlot.setPreferredSize(new java.awt.Dimension(350, 350));

        org.jdesktop.layout.GroupLayout ortogonalPlotLayout = new org.jdesktop.layout.GroupLayout(ortogonalPlot);
        ortogonalPlot.setLayout(ortogonalPlotLayout);
        ortogonalPlotLayout.setHorizontalGroup(
            ortogonalPlotLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 333, Short.MAX_VALUE)
        );
        ortogonalPlotLayout.setVerticalGroup(
            ortogonalPlotLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 368, Short.MAX_VALUE)
        );

        intensityPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        intensityPanel.setMinimumSize(new java.awt.Dimension(160, 160));
        intensityPanel.setPreferredSize(new java.awt.Dimension(280, 280));

        errorPanel.setMinimumSize(new java.awt.Dimension(160, 80));
        errorPanel.setPreferredSize(new java.awt.Dimension(280, 140));

        org.jdesktop.layout.GroupLayout errorPanelLayout = new org.jdesktop.layout.GroupLayout(errorPanel);
        errorPanel.setLayout(errorPanelLayout);
        errorPanelLayout.setHorizontalGroup(
            errorPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 331, Short.MAX_VALUE)
        );
        errorPanelLayout.setVerticalGroup(
            errorPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 145, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout intensityPanelLayout = new org.jdesktop.layout.GroupLayout(intensityPanel);
        intensityPanel.setLayout(intensityPanelLayout);
        intensityPanelLayout.setHorizontalGroup(
            intensityPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, errorPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 331, Short.MAX_VALUE)
        );
        intensityPanelLayout.setVerticalGroup(
            intensityPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(intensityPanelLayout.createSequentialGroup()
                .addContainerGap(113, Short.MAX_VALUE)
                .add(errorPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE))
        );

        upN_upW.setText("UP/N");
        upN_upW.setToolTipText("F7");
        upN_upW.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                upN_upWActionPerformed(evt);
            }
        });

        tc_ntc.setText("TC");
        tc_ntc.setToolTipText("F8");
        tc_ntc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tc_ntcActionPerformed(evt);
            }
        });

        corePanel.setMinimumSize(new java.awt.Dimension(280, 300));
        corePanel.setPreferredSize(new java.awt.Dimension(280, 300));

        stepName.setEditable(false);
        stepName.setMaximumSize(new java.awt.Dimension(115, 40));
        stepName.setMinimumSize(new java.awt.Dimension(115, 25));
        stepName.setPreferredSize(new java.awt.Dimension(115, 30));

        stepInfo.setEditable(false);
        jScrollPane1.setViewportView(stepInfo);

        coreList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        coreList.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                coreListKeyTyped(evt);
            }
        });
        coreList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                coreListValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(coreList);

        jLabel4.setText("Core Info");

        jLabel5.setText("Step Info");

        deleteStep.setText("Delete step (d)");
        deleteStep.setToolTipText("d");
        deleteStep.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteStepActionPerformed(evt);
            }
        });

        insertStep.setText("Insert step (i)");
        insertStep.setToolTipText("i");
        insertStep.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                insertStepActionPerformed(evt);
            }
        });

        jScrollPane6.setBorder(null);

        coreName.setBorder(null);
        coreName.setEditable(false);
        coreName.setMaximumSize(new java.awt.Dimension(115, 40));
        coreName.setMinimumSize(new java.awt.Dimension(115, 25));
        coreName.setPreferredSize(new java.awt.Dimension(115, 30));
        jScrollPane6.setViewportView(coreName);

        org.jdesktop.layout.GroupLayout corePanelLayout = new org.jdesktop.layout.GroupLayout(corePanel);
        corePanel.setLayout(corePanelLayout);
        corePanelLayout.setHorizontalGroup(
            corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(corePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE)
                    .add(jLabel4)
                    .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, insertStep, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, deleteStep, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(jLabel5)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE)
                    .add(stepName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE))
                .addContainerGap())
        );
        corePanelLayout.setVerticalGroup(
            corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(corePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(jLabel5))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(stepName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 58, Short.MAX_VALUE)
                    .add(jScrollPane6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 58, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(corePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(corePanelLayout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 111, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(deleteStep)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(insertStep))
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 185, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pcaPanel.setMinimumSize(new java.awt.Dimension(350, 300));
        pcaPanel.setPreferredSize(new java.awt.Dimension(350, 300));

        exportDirectionsButton.setText("Export Directions");
        exportDirectionsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportDirectionsButtonActionPerformed(evt);
            }
        });

        clearPcaButton.setText("Clear");
        clearPcaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearPcaButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Circles");

        jLabel3.setText("Directions");

        incDirButton.setText("inclor");
        incDirButton.setToolTipText("F9");
        incDirButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                incDirButtonActionPerformed(evt);
            }
        });

        incCircButton.setText("inclor");
        incCircButton.setToolTipText("F9\n");
        incCircButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                incCircButtonActionPerformed(evt);
            }
        });

        excCircButton.setText("exclor");
        excCircButton.setToolTipText("F10");
        excCircButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                excCircButtonActionPerformed(evt);
            }
        });

        excDirButton.setText("exclor");
        excDirButton.setToolTipText("F10");
        excDirButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                excDirButtonActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 15));
        jLabel1.setText("Principal Component Analysis");

        pcaText.setColumns(20);
        pcaText.setEditable(false);
        pcaText.setRows(5);
        pcaText.setText("DEC, INC, INT, MAD, STEP_MIN, STEP_MAX");
        jScrollPane5.setViewportView(pcaText);

        jLabel8.setForeground(new java.awt.Color(102, 102, 102));
        jLabel8.setText("(F9)");

        jLabel9.setForeground(new java.awt.Color(102, 102, 102));
        jLabel9.setText("(F10)");

        exportGraphicsButton.setText("Export Graphics");
        exportGraphicsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportGraphicsButtonActionPerformed(evt);
            }
        });

        clearAllPcaButton.setText("Clear All");
        clearAllPcaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearAllPcaButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout pcaPanelLayout = new org.jdesktop.layout.GroupLayout(pcaPanel);
        pcaPanel.setLayout(pcaPanelLayout);
        pcaPanelLayout.setHorizontalGroup(
            pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pcaPanelLayout.createSequentialGroup()
                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(pcaPanelLayout.createSequentialGroup()
                        .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(pcaPanelLayout.createSequentialGroup()
                                .add(48, 48, 48)
                                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel2)
                                    .add(jLabel3))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(incDirButton)
                                    .add(incCircButton))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, pcaPanelLayout.createSequentialGroup()
                                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(jLabel8)
                                .add(24, 24, 24)))
                        .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(excCircButton)
                            .add(excDirButton)
                            .add(pcaPanelLayout.createSequentialGroup()
                                .add(19, 19, 19)
                                .add(jLabel9))))
                    .add(pcaPanelLayout.createSequentialGroup()
                        .add(50, 50, 50)
                        .add(jLabel1))
                    .add(pcaPanelLayout.createSequentialGroup()
                        .add(29, 29, 29)
                        .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jScrollPane5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 290, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(pcaPanelLayout.createSequentialGroup()
                                .add(9, 9, 9)
                                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(exportDirectionsButton)
                                    .add(exportGraphicsButton))
                                .add(42, 42, 42)
                                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(clearAllPcaButton)
                                    .add(clearPcaButton))))))
                .addContainerGap(19, Short.MAX_VALUE))
        );
        pcaPanelLayout.setVerticalGroup(
            pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, pcaPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .add(18, 18, 18)
                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(pcaPanelLayout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel3))
                    .add(pcaPanelLayout.createSequentialGroup()
                        .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(incCircButton)
                            .add(excCircButton))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(incDirButton)
                            .add(excDirButton))))
                .add(2, 2, 2)
                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel9)
                    .add(jLabel8))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jScrollPane5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(exportDirectionsButton)
                    .add(clearPcaButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(pcaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(exportGraphicsButton)
                    .add(clearAllPcaButton))
                .addContainerGap())
        );

        sitePanel.setMinimumSize(new java.awt.Dimension(370, 300));
        sitePanel.setPreferredSize(new java.awt.Dimension(370, 300));

        finalSiteList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                finalSiteListValueChanged(evt);
            }
        });
        jScrollPane3.setViewportView(finalSiteList);

        virtualButton.setText("Virtual Directions");
        virtualButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                virtualButtonActionPerformed(evt);
            }
        });

        siteList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                siteListValueChanged(evt);
            }
        });
        jScrollPane4.setViewportView(siteList);

        addButton.setText(">");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        addAllButton.setText(">>");
        addAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAllButtonActionPerformed(evt);
            }
        });

        removeButton.setText("<");
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        removeAllButton.setText("<<");
        removeAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeAllButtonActionPerformed(evt);
            }
        });

        jLabel6.setText("Initial Site Info");

        jLabel7.setText("Final Site Info");

        stackingButton.setText("Stacking");
        stackingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stackingButtonActionPerformed(evt);
            }
        });

        saveFinalSiteButton.setText("Save Final Site (TH)");
        saveFinalSiteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveFinalSiteButtonActionPerformed(evt);
            }
        });

        lsaButton.setText("LSA");
        lsaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lsaButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout sitePanelLayout = new org.jdesktop.layout.GroupLayout(sitePanel);
        sitePanel.setLayout(sitePanelLayout);
        sitePanelLayout.setHorizontalGroup(
            sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(sitePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel6)
                    .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 118, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(addAllButton)
                    .add(addButton)
                    .add(removeButton)
                    .add(removeAllButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel7)
                    .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 118, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, sitePanelLayout.createSequentialGroup()
                .addContainerGap(151, Short.MAX_VALUE)
                .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(sitePanelLayout.createSequentialGroup()
                        .add(lsaButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(stackingButton))
                    .add(virtualButton)
                    .add(saveFinalSiteButton))
                .addContainerGap())
        );
        sitePanelLayout.setVerticalGroup(
            sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(sitePanelLayout.createSequentialGroup()
                .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(sitePanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel6)
                            .add(jLabel7))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 160, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 164, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(sitePanelLayout.createSequentialGroup()
                        .add(50, 50, 50)
                        .add(addButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(addAllButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(removeButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(removeAllButton)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 16, Short.MAX_VALUE)
                .add(sitePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(stackingButton)
                    .add(lsaButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(virtualButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(saveFinalSiteButton)
                .addContainerGap())
        );

        sitePanelLayout.linkSize(new java.awt.Component[] {jScrollPane3, jScrollPane4}, org.jdesktop.layout.GroupLayout.VERTICAL);

        jButton1.setText("jButton1");

        jButton2.setText("jButton2");

        actualField.setText("Add Present Field");
        actualField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actualFieldActionPerformed(evt);
            }
        });

        jLabel10.setForeground(new java.awt.Color(102, 102, 102));
        jLabel10.setText("(F8)");

        jLabel11.setForeground(new java.awt.Color(102, 102, 102));
        jLabel11.setText("(F7)");

        jLabel12.setForeground(new java.awt.Color(102, 102, 102));
        jLabel12.setText("Pulse 'c' to change from Core to Site list");

        logoPanel.setPreferredSize(new java.awt.Dimension(170, 48));

        org.jdesktop.layout.GroupLayout logoPanelLayout = new org.jdesktop.layout.GroupLayout(logoPanel);
        logoPanel.setLayout(logoPanelLayout);
        logoPanelLayout.setHorizontalGroup(
            logoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 170, Short.MAX_VALUE)
        );
        logoPanelLayout.setVerticalGroup(
            logoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 64, Short.MAX_VALUE)
        );

        jMenuBar25.setMinimumSize(new java.awt.Dimension(42, 22));

        fileMenu24.setText("File");

        utrechOpen.setText("Open Utrech Format (TH, AF) (ctr+o)");
        utrechOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openOptionActionPerformed(evt);
            }
        });
        fileMenu24.add(utrechOpen);

        g2Open.setText("Open G2 Magnetometer Format (DAT)");
        g2Open.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                g2OpenActionPerformed(evt);
            }
        });
        fileMenu24.add(g2Open);

        romaOpen.setText("Open G2 Roma Format (DAT)");
        romaOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                romaOpenActionPerformed(evt);
            }
        });
        fileMenu24.add(romaOpen);

        michiganOpen.setText("Open Michigan Format (DAT)");
        michiganOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                michiganOpenActionPerformed(evt);
            }
        });
        fileMenu24.add(michiganOpen);

        uchannelsOpen.setText("Open U-channels Format (DAT)");
        uchannelsOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                uchannelsOpenActionPerformed(evt);
            }
        });
        fileMenu24.add(uchannelsOpen);

        utrechAppend.setText("Append Utrech");
        utrechAppend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                utrechAppendActionPerformed(evt);
            }
        });
        fileMenu24.add(utrechAppend);

        g2Append.setText("Append G2 Magnetometer");
        g2Append.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                g2AppendActionPerformed(evt);
            }
        });
        fileMenu24.add(g2Append);

        romaAppend.setText("Append G2 Roma");
        romaAppend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                romaAppendActionPerformed(evt);
            }
        });
        fileMenu24.add(romaAppend);

        michiganAppend.setText("Append Michigan");
        michiganAppend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                michiganAppendActionPerformed(evt);
            }
        });
        fileMenu24.add(michiganAppend);

        uchannelsAppend.setText("Append U-channels");
        uchannelsAppend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                uchannelsAppendActionPerformed(evt);
            }
        });
        fileMenu24.add(uchannelsAppend);

        fileExit.setText("Exit (ctr+w)");
        fileExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileExitsaveOptionActionPerformed(evt);
            }
        });
        fileMenu24.add(fileExit);

        jMenuBar25.add(fileMenu24);

        setJMenuBar(jMenuBar25);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(10, 10, 10)
                                .add(jLabel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 261, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(corePanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE))
                        .add(49, 49, 49)
                        .add(pcaPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(sitePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 336, Short.MAX_VALUE)
                        .add(5, 5, 5))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(stereoPlot, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(ortogonalPlot, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                    .add(upN_upW, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(tc_ntc, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel10)
                                    .add(jLabel11))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 61, Short.MAX_VALUE)
                                .add(logoPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(actualField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 144, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(intensityPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 335, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(tc_ntc)
                                    .add(jLabel10))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(upN_upW)
                                    .add(jLabel11)))
                            .add(layout.createSequentialGroup()
                                .add(1, 1, 1)
                                .add(logoPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(actualField)
                        .add(11, 11, 11)
                        .add(intensityPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(ortogonalPlot, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 372, Short.MAX_VALUE)
                        .add(1, 1, 1))
                    .add(stereoPlot, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 373, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(corePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 285, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jLabel12))
                    .add(sitePanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 313, Short.MAX_VALUE)
                    .add(pcaPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 310, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

     private void dataPoint(java.awt.event.MouseEvent evt, JPanel panel, JLabel label) {

        double d, x, y, dec = Math.PI/2, inc = 0;

        Point point = panel.getMousePosition();

        Dimension tam = panel.getSize();

        if(panel == stereoPlot){

        d = Math.min( tam.width,tam.height ) - 2;
        x = (point.getX() - tam.width/2 + 1) / d * 2;
        y = ((tam.height)/2  - point.getY()) / d * 2;
        if (y != 0)
            dec = Math.atan(x/y);
        if(dec<0)
            dec = dec + Math.PI;
        if(x<0)
            dec = dec + Math.PI;
        if(Math.sin(dec) != 0)
            inc = Math.asin(1 - Math.pow(x / Math.sin(dec), 2));
        else
            inc = Math.asin(1 - Math.pow(y / Math.cos(dec), 2));
        dec = Math.round(Math.toDegrees(dec));
        inc = Math.round(Math.toDegrees(inc));
        if(inc > 0){
            label.setVisible(true);
            String text = "dec: " + (int)dec + ", inc: " + (int)inc;
            label.setText(text);
        }else{
            label.setVisible(false);
            this.repaint();
        }}
    }

    private void tc_ntcActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tc_ntcActionPerformed
        tc = !tc;
        if (tc)
            tc_ntc.setText("NO TC");
        else
            tc_ntc.setText("TC");
        repaint();
    }//GEN-LAST:event_tc_ntcActionPerformed

    private void upN_upWActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_upN_upWActionPerformed
        upNorth = !upNorth;
        if (upNorth)
            upN_upW.setText("UP/W");
        else
            upN_upW.setText("UP/N");
        repaint();
    }//GEN-LAST:event_upN_upWActionPerformed

    private void incCircButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_incCircButtonActionPerformed
        incCircAction();
    }//GEN-LAST:event_incCircButtonActionPerformed
    private void incCircAction(){
       Core core; Vector inclCirc;
       if(stacking){
          core = stackingCore;
       }else{
          core = ((Core)site.get(getSelectedCore()));
       }
       inclCirc = core.getInclCirc();

       Vector steps = new Vector();
       for(int i=0; i<core.getSteps().size(); i++){
            if((Boolean)insertedSteps.get(i))
                steps.add(core.getStepN(i));
       }
       if(!steps.isEmpty()){
           Vector vds = VirtualDirections.PCA(new  Vector(), steps, 0, steps.size(), core.getName());
           vds = VirtualDirections.getRP(vds);
           if(!vds.isEmpty()){
           VD vd = (VD)vds.get(0);
           inclCirc.add(vd);
           }
       }
       plot();
       core.setInclCirc(inclCirc);
       if(!stacking)
          site.set(getSelectedCore(), core);
       else
          stackingCore.setInclCirc(inclCirc);
    }
    private void excCircButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_excCircButtonActionPerformed
        excCircAction();
    }//GEN-LAST:event_excCircButtonActionPerformed
    private void excCircAction(){
       Core core; Vector exclCirc;
       if(stacking){
          core = stackingCore;
       }else{
          core = ((Core)site.get(getSelectedCore()));
       }
       exclCirc = core.getExclCirc();
       Vector steps = new Vector();
       for(int i=0; i<core.getSteps().size(); i++){
            if((Boolean)insertedSteps.get(i))
                steps.add(core.getStepN(i));
       }
       if(!steps.isEmpty()){
           Vector vds = VirtualDirections.PCA(new  Vector(), steps, 0, steps.size(), core.getName());
           vds = VirtualDirections.getDP(vds);
           if(!vds.isEmpty()){
           VD vd = (VD)vds.get(0);           
           exclCirc.add(vd);
           }
       }
       core.setExclCirc(exclCirc);
       if(!stacking)
          site.set(getSelectedCore(), core);
       else
          stackingCore.setExclCirc(exclCirc);
       plot();

    }
    private void exportDirectionsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportDirectionsButtonActionPerformed
        Vector vds = new Vector(); Core core; Vector inclDir, exclDir, inclCirc, exclCirc;

        if(stacking){
            core = stackingCore; if(tc) core = core.beddingCorrection();
            inclDir = core.getInclDir();
            exclDir = core.getExclDir();
            inclCirc = core.getInclCirc();
            exclCirc = core.getExclCirc();

            for(int i=0; i<inclDir.size(); i++){
                vds.add(inclDir.get(i));
            }
            for(int i=0; i<exclDir.size(); i++){
                vds.add(exclDir.get(i));
            }
            for(int i=0; i<inclCirc.size(); i++){
                vds.add(inclCirc.get(i));
            }
            for(int i=0; i<exclCirc.size(); i++){
                vds.add(exclCirc.get(i));
            }
        }else{
        for(int j=0; j<site.size(); j++){

            core = ((Core)site.get(j)); if(tc) core = core.beddingCorrection();
            inclDir = core.getInclDir();
            exclDir = core.getExclDir();
            inclCirc = core.getInclCirc();
            exclCirc = core.getExclCirc();

            for(int i=0; i<inclDir.size(); i++){
                vds.add(inclDir.get(i));
            }
            for(int i=0; i<exclDir.size(); i++){
                vds.add(exclDir.get(i));
            }
            for(int i=0; i<inclCirc.size(); i++){
                vds.add(inclCirc.get(i));
            }
            for(int i=0; i<exclCirc.size(); i++){
                vds.add(exclCirc.get(i));
            }
        }
        }
        JFileChooser chooser = new JFileChooser();
        chooser.changeToParentDirectory();
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            String fileName = chooser.getSelectedFile().getPath();
            ImportExport.writeVD(fileName, vds, tc, true);
       }

    }//GEN-LAST:event_exportDirectionsButtonActionPerformed

    private void clearPcaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearPcaButtonActionPerformed
        Core core;
        if(stacking)
            core=stackingCore;
        else
            core = ((Core)site.get(getSelectedCore()));
        core.setInclDir(new Vector());
        core.setExclDir(new Vector());
        core.setInclCirc(new Vector());
        core.setExclCirc(new Vector());
        if(!stacking)
          site.set(getSelectedCore(), core);
        else
          stackingCore=core;
        plot();
    }//GEN-LAST:event_clearPcaButtonActionPerformed

    private void coreListKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_coreListKeyTyped
        if( Event.DELETE == evt.getKeyChar() || 'd' == evt.getKeyChar() ){ // DELETE STEP
            //System.out.println("Delete");
            int[] indices = coreList.getSelectedIndices();
            actualizeCoreDel(indices);
        }
        if( Event.INSERT == evt.getKeyChar() || 'i' == evt.getKeyChar() ){ // INSERT STEP
            //System.out.println("Insert");
            int[] indices = coreList.getSelectedIndices();
            actualizeCoreIns(indices);
        }
    }//GEN-LAST:event_coreListKeyTyped

    private void coreListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_coreListValueChanged
        plot();
    }//GEN-LAST:event_coreListValueChanged

    private void finalSiteListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_finalSiteListValueChanged
        int selectedCore = finalSiteList.getSelectedIndex();
        if(selectedCore == -1){
            selectedCore = siteList.getSelectedIndex();
            if(selectedCore == -1)
                selectedCore = 0;
        }else
            siteList.clearSelection();
        clearInsertedSteps(0);
        initCoreList(getSelectedCore());
        plot();
    }//GEN-LAST:event_finalSiteListValueChanged

    private void virtualButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_virtualButtonActionPerformed
        //setVisible(false);
        Vector finalSite = finalSite();
        finalSite = Main.drillingCorrection(finalSite);
        Vector vds = VirtualDirections.virtualDirections(finalSite);
        finalSite = Main.beddingCorrection(finalSite);
        Vector vdsTc = VirtualDirections.virtualDirections(finalSite);
        VDWindow vdView = new VDWindow(vds, vdsTc, finalSite);
        vdView.setVisible(true);
}//GEN-LAST:event_virtualButtonActionPerformed

    private void siteListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_siteListValueChanged
        int selectedCore = siteList.getSelectedIndex();
        if(selectedCore == -1){
            selectedCore = finalSiteList.getSelectedIndex();
            if(selectedCore == -1)
                selectedCore = 0;
        }else
            finalSiteList.clearSelection();
        clearInsertedSteps(0);
        initCoreList(getSelectedCore());
        plot();
}//GEN-LAST:event_siteListValueChanged

    private void deleteStepActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteStepActionPerformed
        int[] indices = coreList.getSelectedIndices();
        actualizeCoreDel(indices);
    }//GEN-LAST:event_deleteStepActionPerformed

    private void insertStepActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_insertStepActionPerformed
        int[] indices = coreList.getSelectedIndices();
        actualizeCoreIns(indices);
    }//GEN-LAST:event_insertStepActionPerformed
    private void open(String format, boolean append){
        JFileChooser chooser = new JFileChooser();
        /*FileFilter filter = new FileFilter() {
        public boolean accept(File f) {
                String s = f.getName();
                int i = s.lastIndexOf('.');
                if (i > 0 &&  i < s.length() - 1) {
                    String extension = s.substring(i+1).toLowerCase();
                    if ("th".equals(extension)) 
                        return true;
                    else 
                        return false;
                }else
                    return false;
        }
        public String getDescription() {
                return "TH";
        }  
        };
        chooser.setFileFilter(filter);*/

        //chooser.changeToParentDirectory();
        
        
        
        chooser.setMultiSelectionEnabled(true);
        
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            
            String fileName;
            
            File[] files = chooser.getSelectedFiles();
          for (int i=0; i<files.length; i++){
                          
            if (i>=1) append=true;
            
            fileName = files[i].getPath();
            //System.out.println("You chose to open this file: " + fileName);
            try{
                Vector v = siteIni, newVector = new Vector();
                if(format.equals(UTRECH)){
                    newVector = ImportExport.readUtrech(fileName);
                }
                if(format.equals(G2)){
                    newVector = ImportExport.readG2(fileName);
                }
                if(format.equals(ROMA)){
                    newVector = ImportExport.readRoma(fileName);
                }
                if(format.equals(MICHIGAN)){
                    newVector = ImportExport.readMichigan(fileName);
                }
                if(format.equals(UCHANNELS)){
                    newVector = ImportExport.readUchannels(fileName);
                }
                if(append){
                    for (int j=0; j<newVector.size(); j++)
                        v.add(newVector.get(j));
                }else{
                    clearAll();
                    v=newVector;

                }
                siteIni = v;
                site = Main.drillingCorrection(siteIni);
                initSiteList();
                name = chooser.getSelectedFile().getName();
  
                setTitle("Paleomagnetic Directions, " + name);
                
                String extension = name.substring(name.length()-2).toLowerCase();
                if ("af".equals(extension)) 
                    af = true;
                else
                    af = false;
                    
            }catch(Exception e){
                System.out.println(e);
                JOptionPane.showMessageDialog(this, "File is not valid");

            }
          }
        }    
    }    
    private void save(){
        JFileChooser chooser = new JFileChooser();
        //chooser.changeToParentDirectory();
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            String fileName = chooser.getSelectedFile().getPath();
            Vector finalSite = finalSite();
            if (finalSite.isEmpty())
                JOptionPane.showMessageDialog(this, "Final Site is empty");
            else
                ImportExport.writeSite(fileName, finalSite);
        }
    }
    private void incDirButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_incDirButtonActionPerformed
       incDirAction();
    }//GEN-LAST:event_incDirButtonActionPerformed
    private void incDirAction(){
       Core core; Vector inclDir;
       if(stacking){
          core = stackingCore;
       }else{
          core = ((Core)site.get(getSelectedCore()));
       }
       inclDir = core.getInclDir();
       Vector steps = new Vector();
       for(int i=0; i<core.getSteps().size(); i++){
            if((Boolean)insertedSteps.get(i))
                steps.add(core.getStepN(i));
       }
       if(!steps.isEmpty()){
           Vector vds = VirtualDirections.PCA(new  Vector(), steps, 0, steps.size(), core.getName());
           vds = VirtualDirections.getRV(vds);
           if(!vds.isEmpty()){
           VD vd = (VD)vds.get(0);
           inclDir.add(vd);
           }
       }

      // System.out.println("INCLDIR BUTTON: " + (((VD)inclDir.get(0)).getPos()).getDec());
       core.setInclDir(inclDir);
       if(!stacking)
          site.set(getSelectedCore(), core);
       else
          stackingCore.setInclDir(inclDir);
       plot();

    }
    private void excDirButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_excDirButtonActionPerformed
        excDirAction();
    }//GEN-LAST:event_excDirButtonActionPerformed
    private void excDirAction(){
       Core core; Vector exclDir;
       if(stacking){
          core = stackingCore;
       }else{
          core = ((Core)site.get(getSelectedCore()));
       }
       exclDir = core.getExclDir();
       Vector steps = new Vector();
       for(int i=0; i<core.getSteps().size(); i++){
            if((Boolean)insertedSteps.get(i))
                steps.add(core.getStepN(i));
       }       
       if(!steps.isEmpty()){
           Vector vds = VirtualDirections.PCA(new  Vector(), steps, 0, steps.size(), core.getName());
           vds = VirtualDirections.getDV(vds);
           if(!vds.isEmpty()){
           VD vd = (VD)vds.get(0);
           exclDir.add(vd); 
           }
      }
       core.setExclDir(exclDir);
       if(!stacking)
          site.set(getSelectedCore(), core);
       else
          stackingCore.setExclDir(exclDir);
       plot();
    }
    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        int[] indices = siteList.getSelectedIndices();
        int[] finalIndices = new int[indices.length];
        int i;
        boolean empty = true;
        for(int j=indices.length-1; j>=0; j--){
            i = indices[j];
            if (i != -1){
                empty = false;
                    Object ind = index.getElementAt(i); 
                finalIndex.addElement(ind);
                index.removeElement(ind);
                Object selected = siteList.getSelectedValues()[j];
                finalSiteListModel.addElement(selected);
                siteListModel.removeElement(selected);
                
                finalIndices[j] = finalSiteListModel.size()-1;

                //System.out.println("i: " + i + ", index0: " + index.getElementAt(i));
             }
        }
        if(!empty){
            virtualButton.setEnabled(true);
            stackingButton.setEnabled(true);
            lsaButton.setEnabled(true);
            saveFinalSiteButton.setEnabled(true);
            finalSiteList.setSelectedIndices(finalIndices);
        }
    }//GEN-LAST:event_addButtonActionPerformed

    private void addAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAllButtonActionPerformed
        for(int i=0; i<siteListModel.size(); i++){
            finalIndex.addElement(index.get(i));
            finalSiteListModel.addElement(siteListModel.get(i));
        }
        index.removeAllElements();
        siteListModel.removeAllElements();      
                      
        virtualButton.setEnabled(true);
        stackingButton.setEnabled(true);
        lsaButton.setEnabled(true);
        saveFinalSiteButton.setEnabled(true);
        finalSiteList.setSelectedIndex(0);
    }//GEN-LAST:event_addAllButtonActionPerformed

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        int[] indices = finalSiteList.getSelectedIndices();
        int[] finalIndices = new int[indices.length];
        int i;
        boolean empty = true; 
        for (int j=(indices.length-1); j>=0; j--){
            i = indices[j];
            if(i != -1){
                //System.out.println("i: " + i);
                empty = false;
                Object ind = finalIndex.getElementAt(i);
                index.addElement(ind);
                finalIndex.removeElement(ind);
                Object selected = finalSiteList.getSelectedValues()[j];
                siteListModel.addElement(selected);
                finalSiteListModel.removeElement(selected);
                finalIndices[j] = siteListModel.size()-1;
   
            }
        }
        //System.out.println("i: " + i + ", index0: " + index.getElementAt(i));
        if(!empty){
           siteList.setSelectedIndices(finalIndices);
        } 
        if(finalIndex.size() == 0){
            virtualButton.setEnabled(false);
            stackingButton.setEnabled(false);
            lsaButton.setEnabled(false);
            saveFinalSiteButton.setEnabled(false);
            stacking = false;
        }
    }//GEN-LAST:event_removeButtonActionPerformed

    private void removeAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeAllButtonActionPerformed
        for(int i=0; i<finalSiteListModel.size(); i++){
            index.addElement(finalIndex.get(i));
            siteListModel.addElement(finalSiteListModel.get(i));
        }
        finalIndex.removeAllElements();
        finalSiteListModel.removeAllElements();
        
        virtualButton.setEnabled(false);
        stackingButton.setEnabled(false);
        lsaButton.setEnabled(false);
        saveFinalSiteButton.setEnabled(false);
        stacking = false;
        siteList.setSelectedIndex(0);
    }//GEN-LAST:event_removeAllButtonActionPerformed

    private void stackingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stackingButtonActionPerformed
        stacking = !stacking;
        clearValidStepsStaking();
        if(stacking){
            stackingCore = Statistics.stacking(stackingSite());
            stackingCore.setValidStep(validStepsStaking);
        }else
            stackingCore = null;
        clearInsertedSteps(0);
        plot();
        initCoreList(getSelectedCore());
}//GEN-LAST:event_stackingButtonActionPerformed

    private void actualFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actualFieldActionPerformed
       ActualFieldWindow actualFieldWindow = new ActualFieldWindow(this);
       actualFieldWindow.setVisible(true);
}//GEN-LAST:event_actualFieldActionPerformed

    private void fileExitsaveOptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileExitsaveOptionActionPerformed
        int exit = JOptionPane.showConfirmDialog(null,"Do  you want to exit the program?", "", JOptionPane.YES_NO_OPTION);
        if (exit == JOptionPane.YES_OPTION)
            System.exit(0);
}//GEN-LAST:event_fileExitsaveOptionActionPerformed

    private void openOptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openOptionActionPerformed
        open(UTRECH, false);
    
}//GEN-LAST:event_openOptionActionPerformed

private void saveFinalSiteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveFinalSiteButtonActionPerformed
    save();
}//GEN-LAST:event_saveFinalSiteButtonActionPerformed

private void g2OpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_g2OpenActionPerformed
    open(G2, false);
}//GEN-LAST:event_g2OpenActionPerformed

private void uchannelsOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uchannelsOpenActionPerformed
    open(UCHANNELS, false);
}//GEN-LAST:event_uchannelsOpenActionPerformed

private void utrechAppendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_utrechAppendActionPerformed
    open(UTRECH, true);
}//GEN-LAST:event_utrechAppendActionPerformed

private void g2AppendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_g2AppendActionPerformed
    open(G2, true);
}//GEN-LAST:event_g2AppendActionPerformed

private void uchannelsAppendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uchannelsAppendActionPerformed
    open(UCHANNELS, true);
}//GEN-LAST:event_uchannelsAppendActionPerformed

private void exportGraphicsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportGraphicsButtonActionPerformed

        JFileChooser chooser = new JFileChooser();
        chooser.changeToParentDirectory();
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            String fileName = chooser.getSelectedFile().getPath();
            Core core;
            if(stacking){
              core = stackingCore;
            }else{
              core = ((Core)site.get(getSelectedCore()));
            }
            System.out.println("EXPORT, selected core name: "+core.getName());
            Print2DtoStream sp = new Print2DtoStream(fileName + ".eps", core, tc, upNorth);
            //sp = new Print2DtoStream(fileName + ".eps", (Core)site.get(1), tc, upNorth, inclDir, exclDir, inclCirc, exclCirc);
        }
}//GEN-LAST:event_exportGraphicsButtonActionPerformed

private void clearAllPcaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearAllPcaButtonActionPerformed
     Core core;
     for(int i=0; i<site.size(); i++){
        core= ((Core)site.get(i));
        core.setInclDir(new Vector());
        core.setExclDir(new Vector());
        core.setInclCirc(new Vector());
        core.setExclCirc(new Vector());
        site.set(i, core);
     }
     if(stacking){
        core= stackingCore;
        core.setInclDir(new Vector());
        core.setExclDir(new Vector());
        core.setInclCirc(new Vector());
        core.setExclCirc(new Vector());
     }
     plot();
}//GEN-LAST:event_clearAllPcaButtonActionPerformed

private void romaOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_romaOpenActionPerformed
      open(ROMA, false);
}//GEN-LAST:event_romaOpenActionPerformed

private void romaAppendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_romaAppendActionPerformed
     open(ROMA, true);
}//GEN-LAST:event_romaAppendActionPerformed

private void michiganOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_michiganOpenActionPerformed
    open(MICHIGAN, false);
}//GEN-LAST:event_michiganOpenActionPerformed

private void michiganAppendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_michiganAppendActionPerformed
    open(MICHIGAN, true);
}//GEN-LAST:event_michiganAppendActionPerformed

private void lsaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lsaButtonActionPerformed
        Vector finalSite = finalSite();
        finalSite = Main.drillingCorrection(finalSite);

        Vector vds = new Vector();
        if (tc)
            vds = VirtualDirections.virtualDirections(finalSite);
        else{
            finalSite = Main.beddingCorrection(finalSite);
            vds = VirtualDirections.virtualDirections(finalSite);
        }
            
        LSAWindow lsaWiew = new LSAWindow(vds,finalSite);
        lsaWiew.setVisible(true);
}//GEN-LAST:event_lsaButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainWindow().setVisible(true);
            }
        });
    }
    
     private void initSiteList(){

         upNorth=false; tc=false; stacking=false; clearInsertedSteps(0);
         siteList.removeAll();
         finalSiteList.removeAll();
         siteListModel.removeAllElements();
         finalSiteListModel.removeAllElements();
         index.removeAllElements();
             
         for (int i=0; i<site.size(); i++){
             index.addElement(i);
             siteListModel.addElement(((Core)site.get(i)).getName());
         }
         siteList.setModel(siteListModel);
         finalSiteList.setModel(finalSiteListModel);

         int i = siteList.getSelectedIndex();
         int selectedCore = 0;
         if (i != -1)
            selectedCore = ((Integer)index.getElementAt(i)).intValue();
         Core core = (Core)site.get(selectedCore);
         coreName.setText(core.getName());

         initCoreList(selectedCore);     
     }

    private void initCoreList(int selectedCore){
        String info;

        int[] selectedSteps = coreList.getSelectedIndices();
        if (selectedSteps.length < 1){
            selectedSteps = new int[1];
            selectedSteps[0] = 0;
        }
        int selectedStep = selectedSteps[0];

         coreList.removeAll();
         DefaultListModel list = new DefaultListModel();
         Vector steps; Core core;
         if(stacking){
                 core = stackingCore;
         }else{
             core = ((Core)site.get(selectedCore));
         }
         steps = core.getSteps();
         if(insertedSteps.isEmpty()){
             clearInsertedSteps(steps.size());
         }
         for (int i=0; i<steps.size(); i++){
             if((Boolean)core.getValidStep().get(i)){
                 info = Double.toString(((Step)steps.get(i)).getTemp());
                 if((Boolean)insertedSteps.get(i))
                     info = info + " *";                 
             }else
                 info = "---";
         list.addElement(info);
         }
        coreList.setModel(list);
        //System.out.println("tam: " + list.size());
        if(selectedSteps[selectedSteps.length-1] > list.size()){
            selectedSteps = new int[1];
            selectedSteps[0] = 0;
            selectedStep = 0;
        }
        coreList.setSelectedIndices(selectedSteps);
        infoSelectedCore(selectedCore, selectedStep);
    }
          
    private void infoSelectedCore(int selectedCore, int selectedStep){
        Core core; 
        if(stacking){
             core = stackingCore;
         }else{ 
             core = (Core)site.get(selectedCore);
         }
         if(tc){
             core = core.beddingCorrection();
         }

        if(af)
            stepName.setText("AF (mT): " +  core.getStepN(selectedStep).getTemp());
         else
            stepName.setText("Temp (ºC): " +  core.getStepN(selectedStep).getTemp());
        if((Boolean)core.getValidStep().get(selectedStep)){
             Position pos = ((Step) core.getStepN(selectedStep)).getPos();
             stepInfo.setText("Dec: " + Math.round(pos.getDec()) + "º\nInc: " + Math.round(pos.getInc()) + "º\nInt: " + Math.round(pos.getInt()*100)/100d + " E-6A/m\nError: "
                     + Math.round(pos.getError()*100)/100d);
            if(stacking){
                String text="Dec: " + Math.round(pos.getDec()) + "º\nInc: " + Math.round(pos.getInc()) + "º\nInt: " + Math.round(pos.getInt()*100)/100d + " E-6A/m\nAlfa: "
                         + Math.round(pos.getError()*100)/100d;
                text = text + "\n\nNum. stpes: " + stackingCore.getStepN(selectedStep).getNumSteps();
                stepInfo.setText(text);
            }
         }else
             stepInfo.setText("---");
     }
                    
    private void stereonet(Core core, int selectedStep) {

     if(tc){
        core = core.beddingCorrection();}

      Vector inclCirc=core.getInclCirc(), exclCirc=core.getExclCirc();


     //System.out.println("DEC CORE STEP 0: " + ((Step)((Core)site.get(getSelectedCore())).getStepN(0)).getPos().getDec());
     //if(!inclCirc.isEmpty())
     //     System.out.println("DEC INCL CIRC: " + (((VD)((Core)site.get(getSelectedCore())).getInclCirc().get(0))).getPos().getDec());

      Graphics2D g = (Graphics2D) stereoPlot.getGraphics();
      stereoPlot.paint(g);
            
      if (tc) {
         g.drawString("TC", TOP_ALIGNMENT + 15,TOP_ALIGNMENT + 15);
      }else{
         g.drawString("NO TC", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
      }
      
      Dimension tam = stereoPlot.getSize(); // plotPanel size
      int d = Math.min( tam.width,tam.height ) - 2; // diameter
      int x0 = (tam.width - d) / 2 + 1;
      int y0 = (tam.height - d) / 2 + 1;
     
      g.setColor (Color.GRAY);
      g.drawOval(x0, y0, d, d);// border circunference
      g.drawLine(x0+d/2, y0, x0+d/2, y0+d); 
      g.drawLine(x0, y0+d/2, x0+d, y0+d/2);
      
      g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 10));
      g.drawString("S", x0+d/2, y0+d); g.drawString("N", x0+d/2, y0+10);
      g.drawString("E", x0+d, y0+d/2); g.drawString("W", x0-5, y0+d/2);
      g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 12));
  
      g.setColor (Color.RED);
      
      x0 = x0 + d/2; y0 = y0 + d/2; // circunference centre     
           
      Step step; double dec, inc, r; int x=0, y=0, x_prev, y_prev;
      BasicStroke strokeIni = (BasicStroke) g.getStroke();
      float[] dashPattern = { d/70, d/70, d/70, d/70 };
      float[] dashPattern2 = { d/70, d/70, d/30, d/30 };
      BasicStroke strokeDash = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern, 0);
      BasicStroke strokeDash2 = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern2, 0);

      selectedStep = core.getSelectedValidStep(selectedStep);
      core = core.getValidCore();
      Vector v = core.getSteps();
      for(int i=0; i<v.size(); i++){
         step = (Step) v.get(i);
         dec = step.getPos().getDec();
         inc = step.getPos().getInc();
         //System.out.println("paso: " + step.getTemp() + ", x: " + step.getPos().getX() + ", y: " + step.getPos().getY() + ",z: " + step.getPos().getZ());  
         //System.out.println("dec: " + dec + "inc: " + inc );     
          dec = Math.toRadians(dec);
          inc = Math.toRadians(inc);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
          x_prev = x;
          y_prev = y;
          x = (int) Math.round(r * Math.sin(dec));
          y = (int) Math.round(r * Math.cos(dec));
          //System.out.println("dec: " + dec + "inc: " + inc + ", y: " + r *Math.cos(dec) + ", y: " +y + ", y0: " +y0 + ",r:" +r +",y+y0: " +(-y+y0));
          if(i == selectedStep)
             g.setColor (Color.BLUE);
          if(inc > 0)
              g.fillOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); // lower hemisphere
          else
              g.drawOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); // upper hemisphere
         g.setColor (Color.RED);
         if(i>=1){
             g.setStroke(new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern, 0));
             g.drawLine(x_prev+x0, -y_prev+y0, x+x0, -y+y0);
             g.setStroke(strokeIni);
         }
       }
       
      //PLOT PCA 
      VD vd;
      for(int i=0; i<inclCirc.size(); i++){ //INCLOR
        vd = (VD)inclCirc.get(i);
            Position pos = vd.getPos(); //dec,inc polo plano

            dec = Math.toRadians(pos.getDec());
            inc = Math.toRadians(pos.getInc());
            r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
            x = (int) Math.round(r * Math.sin(dec));
            y = (int) Math.round(r * Math.cos(dec));

            pos = pos.rot90();

            if(i < (inclCirc.size()-1))
                g.setColor(Color.LIGHT_GRAY);
            else
                g.setColor(Color.GRAY);
            //paint circle
            plotArc(g, pos.getDec(), pos.getInc(), d, x0, y0 );

            //paint pole
            if(inc>0)
                g.fillOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); //lower hemisphere
            else
                g.drawOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); // upper hemisphere  
      }
      for(int i=0; i<exclCirc.size(); i++){ //EXCLOR
        vd = (VD)exclCirc.get(i);
            Position pos = vd.getPos();            
            dec = Math.toRadians(pos.getDec());
            inc = Math.toRadians(pos.getInc());
            r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
            x = (int) Math.round(r * Math.sin(dec));
            y = (int) Math.round(r * Math.cos(dec));
            pos = pos.rot90();
            if(i < (exclCirc.size()-1))
                 g.setColor(Color.LIGHT_GRAY);
            else
                 g.setColor(Color.GRAY);
            plotArc(g, pos.getDec(), pos.getInc(), d, x0, y0 );
            if(inc>0)
                g.fillOval(x+x0-d/90, -y+y0-d/90, d/45, d/45);
            else
                g.drawOval(x+x0-d/90, -y+y0-d/90, d/45, d/45);
      }   
      if(!stacking){
      //Plot Drilling vector
      if(tc){
        dec = Math.toRadians(core.getTrendCorrected());
        inc = Math.toRadians(core.getPlungeCorrected());
      }else{          
          dec = Math.toRadians(core.getTrend());
          inc = Math.toRadians(core.getPlunge());
      }
      r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
      x = (int) Math.round(r * Math.sin(dec));
      y = (int) Math.round(r * Math.cos(dec));
      g.setColor (new Color(0,150,0));
      if(inc > 0)
          g.fillOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); // lower hemisphere
      else
          g.drawOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); // upper hemisphere
      g.fillOval(tam.width-52, tam.height-23, 6, 6); // legend
      g.drawString("Drilling", tam.width - 45, tam.height - 18);
      }
      //Plot Actual Field vector
      if(actualPos != null){

          Position presentField = actualPos;
          if(tc){
              Step stepPresentField = new Step(0,presentField);
              Core corePresentField = core; corePresentField.setSteps(new Vector()); corePresentField.setStepN(stepPresentField);
              corePresentField = corePresentField.beddingCorrection();
              presentField = (corePresentField.getStepN(0)).getPos();
          }

          dec = Math.toRadians(presentField.getDec());
          inc = Math.toRadians(presentField.getInc());
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
          x = (int) Math.round(r * Math.sin(dec));
          y = (int) Math.round(r * Math.cos(dec));
          g.setColor (new Color(0,50,0));
          if(inc > 0)
              g.fillOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); // lower hemisphere
          else
              g.drawOval(x+x0-d/90, -y+y0-d/90, d/45, d/45); // upper hemisphere
          g.fillOval(tam.width-52, tam.height-36, 6, 6); // legend
          g.drawString("Present Field", tam.width - 45, tam.height - 31);
      }
      //Plot S0
      if(!tc){
          g.setColor(new Color(70,100,240));
          plotArc1(g, core.getStrike(), core.getDip(), d, x0, y0 );
          g.drawLine(tam.width-52, tam.height-10,tam.width-49, tam.height-10); g.drawLine(tam.width-48, tam.height-10,tam.width-45, tam.height-10); 
          g.drawString("S0", tam.width - 45, tam.height - 5);
      }

     }

    public void plotArc(Graphics2D g, double dec, double inc, int d, double x0, double y0){//d->diameter x0,y0->center

        BasicStroke strokeIni = new BasicStroke(1);
        float[] dashPattern2 = { d/70, d/70, d/30, d/30 };
        BasicStroke strokeDash2 = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern2, 0); //discontinuous line
        Arc2D gArc;

        if(inc<0){
            g.setStroke(strokeDash2); //upper hemisphere
        }else{
            g.setStroke(strokeIni);  // lower hemisphere
        }

         CircunferenceArc arc = new CircunferenceArc(dec, inc, d/2, x0, y0);
        
         gArc = new Arc2D.Double(
                arc.getX0()-arc.getR0(), arc.getY0()-arc.getR0(), //left upper corner
                arc.getR0()*2, arc.getR0()*2, 
                arc.getStart(), arc.getExtent(), Arc2D.OPEN);

         g.draw(gArc);

         /*g.fillOval((int)arc.getX(),(int)arc.getY(),10,10);
         g.setColor(Color.GREEN);
         g.fillOval((int)arc.getX1(),(int)arc.getY1(),5,5);
         g.fillOval((int)arc.getX2(),(int)arc.getY2(),5,5);
         g.fillOval((int)arc.getX3(),(int)arc.getY3(),5,5);*/

       if(inc<0){
            g.setStroke(strokeIni); 
        }else{
            g.setStroke(strokeDash2);
        }

         arc = new CircunferenceArc(dec+180, inc, d/2, x0, y0); //to paint the other hemisphere
         gArc = new Arc2D.Double(
                arc.getX0()-arc.getR0(), arc.getY0()-arc.getR0(), //left upper corner
                arc.getR0()*2, arc.getR0()*2, 
                arc.getStart(), arc.getExtent(), Arc2D.OPEN);

         g.draw(gArc);
       
     }
       public void plotArc1(Graphics2D g, double dec, double inc, int d, double x0, double y0){//d->diameter x0,y0->center

         float[] dashPattern2 = { d/70, d/70, d/30, d/30 };
         BasicStroke strokeDash2 = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern2, 0); //discontinuous line
         g.setStroke(strokeDash2);
         
         CircunferenceArc arc = new CircunferenceArc(dec, inc, d/2, x0, y0);
        
         Arc2D gArc = new Arc2D.Double(
                arc.getX0()-arc.getR0(), arc.getY0()-arc.getR0(), //left upper corner
                arc.getR0()*2, arc.getR0()*2, 
                arc.getStart(), arc.getExtent(), Arc2D.OPEN);

         g.draw(gArc);
 }
      
      private void zijderveldPlot(Core core, int selectedStep){ // ortogonal proyection resized
      
      if(tc)
         core = core.beddingCorrection();

      Vector inclDir=core.getInclDir(), exclDir=core.getExclDir();

      Graphics2D g = (Graphics2D) ortogonalPlot.getGraphics();
      ortogonalPlot.paint(g);
          
      if (tc) {
         g.drawString("TC, ", TOP_ALIGNMENT + 15,TOP_ALIGNMENT + 15);
      }else{
         g.drawString("NO TC, ", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
      }
      if(upNorth){
         g.drawString("up/N", TOP_ALIGNMENT + 70,TOP_ALIGNMENT + 15);    
      }else{
         g.drawString("up/W", TOP_ALIGNMENT + 70,TOP_ALIGNMENT + 15);
      }
      
      Dimension tam = ortogonalPlot.getSize(); // plotPanel size
      int dx = tam.width - 30; 
      int dy = tam.height - 30 ;
      int d = Math.min( tam.width,tam.height ) - 10; // diameter
      int x0 = 15;
      int y0 = 15;
     
      selectedStep = core.getSelectedValidStep(selectedStep);
      core = core.getValidCore();
      Vector v = core.getSteps(); 
      Step step; int a=0, b=0, c=0, a_prev, b_prev, c_prev; double intensity = 1;
      BasicStroke strokeIni = (BasicStroke) g.getStroke();
      float[] dashPattern = { d/70, d/70, d/70, d/70 };
      float[] dashPattern2 = { d/70, d/70, d/30, d/30 };
      BasicStroke strokeDash = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern, 0);
      BasicStroke strokeDash2 = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern2, 0);
              
      double a_max = 0, b_max = 0, c_max = 0, a_min = 0 , b_min = 0, c_min = 0, aux; // To resize
      double x_len, y_len; int x_min, y_min, x_max, y_max;
      for(int i=0; i<v.size(); i++){
         step = (Step) v.get(i);
         //intensity = step.getPos().getInt();
         aux = (step.getPos().getX()); 
         if(aux > a_max)
             a_max = aux;
         if(aux < a_min)
             a_min = aux;
         aux = (step.getPos().getY()); 
         if(aux > b_max)
             b_max = aux;
         if(aux < b_min)
             b_min = aux;
         aux = (step.getPos().getZ()); 
         if(aux > c_max)
             c_max = aux;
         if(aux < c_min)
             c_min = aux;
      }
      a_min = Math.abs(a_min) / intensity; b_min = Math.abs(b_min) / intensity; c_min = Math.abs(c_min) / intensity;
      a_max = a_max / intensity; b_max = b_max / intensity; c_max = c_max / intensity;
      // square centre resized to optimize the space
      if(upNorth){ // up/N
        x_len = c_max + c_min;   
        x_min = (int) (c_min * dx / x_len);
        x_max = (int) (c_max * dx / x_len);
        y_len = Math.max(b_min, a_max) + Math.max(b_max, a_min);
        y_max = (int) (Math.max(b_min, a_max) * dy / y_len);
        y_min = (int) (Math.max(b_max, a_min) * dy / y_len);
      }
      else{ // up/W
        x_len = b_max + b_min;
        x_min = (int) (b_max * dx / x_len);
        x_max = (int) (b_min * dx / x_len);
        y_len = Math.max(c_min, a_max) + Math.max(c_max, a_min);
        y_max = (int) (Math.max(c_min, a_max) * dy / y_len);
        y_min = (int) (Math.max(c_max, a_min) * dy / y_len);
        
      } 
      x0 = x0 + x_min; y0 = y0 + y_max; // square centre
            
      g.setColor (Color.GRAY);
      g.drawLine(x0, y0-y_max, x0, y0+y_min); // square axes
      g.drawLine(x0-x_min, y0, x0+x_max, y0);
      
      //labels
      g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 10));
      if(x_max>Math.abs(x_min)){
         g.drawLine(x0+(int)(x_max*0.9), y0-3, x0+(int)(x_max*0.9), y0+3);   
         g.drawString((int)(x_max*x_len/dx)+"E-6A/m", x0+x_max-55, y0-4);
      }else{
         g.drawLine(x0-(int)(x_min*0.9), y0-3, x0-(int)(x_min*0.9), y0+3);   
         g.drawString("-"+(int)(x_min*x_len/dx)+"E-6A/m", x0-x_min, y0-4);
      }
      if(y_max>Math.abs(y_min)){
         g.drawLine(x0-3, y0-(int)(y_max*0.9), x0+3, y0-(int)(y_max*0.9));
         g.drawString((int)(y_max*y_len/dy)+"E-6A/m", x0+5, y0-(int)(y_max*0.9)+4);
      }else{
         g.drawLine(x0-3, y0+(int)(y_min*0.9), x0+3, y0+(int)(y_min*0.9));
         g.drawString("-"+(int)(y_min*y_len/dy)+"E-6A/m", x0+5, y0+(int)(y_min*0.9)+4);
      }
      g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 12));
      
      g.setColor (Color.RED);
      
      for(int i=0; i<v.size(); i++){
         step = (Step) v.get(i);
         a_prev = a; b_prev = b; c_prev = c;
         if(upNorth){
             a = (int) (step.getPos().getX() * 0.9 * dy / intensity / y_len);
             b = (int) (step.getPos().getY() * 0.9 * dy / intensity / y_len);
             c = (int) (step.getPos().getZ() * 0.9 * dx / intensity / x_len);
         }else{
             a = (int) (step.getPos().getX() * 0.9 * dy / intensity / y_len);
             b = (int) (step.getPos().getY() * 0.9 * dx / intensity / x_len);
             c = (int) (step.getPos().getZ() * 0.9 * dy / intensity / y_len);
         }
         
         if(i == selectedStep)
             g.setColor (Color.BLUE);
 
        
         if( upNorth ){ 
            // up/N
            g.fillOval(x0+c-d/90, y0-(-b)-d/90, d/45, d/45); // declination
            g.drawOval(x0+c-d/90, y0-a-d/90, d/45, d/45); // inclination
            g.setColor (Color.RED);
            if(i>=1){
                g.setStroke(strokeDash);
                g.drawLine(x0+c_prev, y0-a_prev, x0+c, y0-a);
                g.drawLine(x0+c_prev, y0-(-b_prev), x0+c, y0-(-b));
                g.setStroke(strokeIni);
            }
         }else{ 
            // up/W
            g.fillOval(x0+(-b)-d/90, y0-(-c)-d/90, d/45, d/45); // declination
            g.drawOval(x0+(-b)-d/90, y0-a-d/90, d/45, d/45); // inclination
            g.setColor (Color.RED);
            if(i>=1){
                g.setStroke(strokeDash);
                g.drawLine(x0+(-b_prev), y0-(-c_prev), x0+(-b), y0-(-c));
                g.drawLine(x0+(-b_prev), y0-a_prev, x0+(-b), y0-a);
                g.setStroke(strokeIni);
            }         }
         g.setColor(Color.RED);
       }
      
      //PLOT PCA 
      VD vd;
      //g.setColor(new Color(150,0,0));
      g.setStroke(strokeDash2);
      double cte = 500;
      for(int i=0; i<inclDir.size(); i++){
      if(inclDir.size()>0){ //INCLOR
            vd = (VD)inclDir.get(i);
                Position pos = vd.getPos();
                if(i < (inclDir.size()-1))
                     g.setColor(Color.LIGHT_GRAY);
                else
                     g.setColor(Color.GRAY);
                if(upNorth){
                    a = (int) (pos.getX() * cte * dy / y_len);
                    b = (int) (pos.getY() * cte * dy / y_len);
                    c = (int) (pos.getZ() * cte * dx / x_len);

                     g.drawLine(x0-c, y0+a, x0+c, y0-a);
                     g.drawLine(x0-c, y0-b, x0+c, y0-(-b));
                 }else{
                    a = (int) (pos.getX() * cte * dy / y_len);
                    b = (int) (pos.getY() * cte * dx / x_len);
                    c = (int) (pos.getZ() * cte * dy / y_len);

                     g.drawLine(x0+b, y0+a, x0+(-b), y0-a);
                     g.drawLine(x0+b, y0-c, x0+(-b), y0-(-c));
                 }
       }
       }
       for(int i=0; i<exclDir.size(); i++){
       if(exclDir.size()>0){ //EXCLOR
            vd = (VD)exclDir.get(i);
                Position pos = vd.getPos();
                Position pos_mean = vd.getPosMean();
                if(i < (exclDir.size()-1))
                     g.setColor(Color.LIGHT_GRAY);
                else
                     g.setColor(Color.GRAY);
                if(upNorth){
                     int amean = ((int)(pos_mean.getX() * 0.9 * dy /  y_len));
                     int bmean = ((int)(pos_mean.getY() * 0.9 * dy /  y_len));
                     int cmean = ((int)(pos_mean.getZ() * 0.9 * dx /  x_len));
                     a = (int) (pos.getX() * cte * dy /  y_len );
                     b = (int) (pos.getY() * cte * dy /  y_len );
                     c = (int) (pos.getZ() * cte * dx /  x_len );

                     b = -b; bmean = -bmean;
                     g.drawLine(x0+(cmean - c), y0-(amean - a), x0+(cmean + c), y0-(amean + a));
                     g.drawLine(x0+(cmean - c), y0-(bmean - b), x0+(cmean + c), y0-(bmean + b));

                 }else{
                     int amean = ((int)(pos_mean.getX() * 0.9 * dy /  y_len));
                     int bmean = ((int)(pos_mean.getY() * 0.9 * dx /  x_len));
                     int cmean = ((int)(pos_mean.getZ() * 0.9 * dy /  y_len));
                     a = (int) (pos.getX() * cte * dy /  y_len);
                     b = (int) (pos.getY() * cte * dx /  x_len);
                     c = (int) (pos.getZ() * cte * dy /  y_len);

                     b = -b; bmean = -bmean; c = -c; cmean = -cmean;
                     g.drawLine(x0+(bmean - b), y0-(amean - a), x0+(bmean + b), y0-(amean + a));
                     g.drawLine(x0+(bmean - b), y0-(cmean - c), x0+(bmean + b), y0-(cmean + c));
                 }
       }
       }
       g.setColor(Color.RED);
       g.setStroke(strokeIni);
       
    }
    
    private void intensityPlot(Core core, int selectedStep) {
     
      Graphics2D g = (Graphics2D) intensityPanel.getGraphics();
      intensityPanel.paint(g);
      
      if(tc)
          core = core.beddingCorrection();
      if(stacking)
          errorPlot(core, selectedStep);
        
      Dimension tam = intensityPanel.getSize(); // plotPanel size
      if(stacking)
          tam.height = tam.height/2;
      int d = Math.max(tam.height, tam.width) / 10;
      int x0 = d/2; int y0 = d/2+10; // nw corner
      BasicStroke strokeIni = (BasicStroke) g.getStroke();
      float[] dashPattern = { d/7, d/7, d/7, d/7 };
      
      g.drawString("Intensity (E-6A/m)", 15, 15);
      if (af)
          g.drawString("vs Demag. step (mT)", 140, 15);
      else
          g.drawString("vs Demag. step (ºC)", 140, 15);
      
      double intMin = 10, intMax = 0, aux; int inten, temp, inten_prev, temp_prev;
      
      selectedStep = core.getSelectedValidStep(selectedStep);
      core = core.getValidCore();
      for(int i=0; i<core.getSteps().size(); i++){
          aux = core.getStepN(i).getPos().getInt();
          if(intMin > aux)
              intMin = aux;
          if(intMax < aux)
              intMax = aux;
      }
      
      double stepMin=core.getStepN(0).getTemp(); 
      double stepMax=core.getStepN(core.getSteps().size()-1).getTemp();
      double stepInt=core.getStepN((int)core.getSteps().size()/2).getTemp();
      double s_inten = (tam.height-d)/(intMax); // scale y-intensity
      double s_temp = (tam.width-d)/(stepMax + stepMin); // scale x-temperature
              
      y0 = y0 + (int)(intMax*s_inten); // centre
      
      g.setColor (Color.GRAY);
      g.drawLine(x0, y0, x0+tam.width-d, y0); // axes
      g.drawLine(x0, y0 , x0, y0 - (int)(intMax*s_inten));
      g.setColor(Color.RED);
      
      inten = (int) (core.getStepN(0).getPos().getInt() * s_inten);
      temp = (int) (core.getStepN(0).getTemp() * s_temp);
      for(int i=0; i<core.getSteps().size(); i++){
          inten_prev = inten;
          temp_prev = temp;
          inten = (int) (core.getStepN(i).getPos().getInt() * s_inten);
          temp = (int) (core.getStepN(i).getTemp() * s_temp);
          
          if(i == selectedStep)
               g.setColor (Color.BLUE);

          g.fillOval(x0 + temp - d/9, y0 - inten - d/9, (int)(d/4.5), (int)(d/4.5)); // intensity vs temperature step
          
          g.setColor(Color.RED);
          if(i>0){
              g.setStroke(new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern, 0));
              g.drawLine(x0 + temp_prev, y0 - inten_prev, x0 + temp, y0 - inten);
              g.setStroke(strokeIni);
          }
               
      }
      
      //Draw scale
      g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 10));
      g.setColor(Color.GRAY);
      aux = (intMin+intMax)/2;
      g.drawLine(x0-5, y0-(int)(aux*s_inten), x0+5, y0-(int)(aux*s_inten));
      g.drawString(Integer.toString((int)aux), x0-11, y0-(int)(aux*s_inten)+11);
      
      g.drawLine(x0-5, y0-(int)(intMax*s_inten), x0+5, y0-(int)(intMax*s_inten));
      g.drawString(Integer.toString((int)intMax), x0-11, y0-(int)(intMax*s_inten)+11);
      
      g.drawLine(x0-5, y0-(int)(intMin*s_inten), x0+5, y0-(int)(intMin*s_inten));
      g.drawString(Integer.toString((int)intMin), x0-11, y0-(int)(intMin*s_inten)+11);
      
      g.drawLine(x0+(int)(stepInt*s_temp),y0-5,x0+(int)(stepInt*s_temp),y0+5);
      g.drawString(Integer.toString((int)stepInt), x0+(int)(stepInt*s_temp), y0-1);
      
      g.drawLine(x0+(int)(stepMax*s_temp),y0-5, x0+(int)(stepMax*s_temp),y0+5);
      g.drawString(Integer.toString((int)stepMax), x0+(int)(stepMax*s_temp), y0-1);
      
      g.drawLine(x0+(int)(stepMin*s_temp), y0-5, x0+(int)(stepMin*s_temp), y0+5);
      g.drawString(Integer.toString((int)stepMin), x0+(int)(stepMin*s_temp), y0-1);

    }
    
      private void errorPlot(Core core, int selectedStep) {
     
      Graphics2D g = (Graphics2D) errorPanel.getGraphics();
      errorPanel.paint(g);

      g.drawString("Error", 15, 15);
      if (af)
          g.drawString("vs Demag. step (mT)", 50, 15);
      else
          g.drawString("vs Demag. step (ºC)", 50, 15);
            
      Dimension tam = errorPanel.getSize(); // plotPanel size
      int d = Math.max(tam.height, tam.width) / 10;
      int x0 = d/2; int y0 = d/2; // nw corner
      BasicStroke strokeIni = (BasicStroke) g.getStroke();
      float[] dashPattern = { d/7, d/7, d/7, d/7 };
      
      double errMin = 10, errMax = 0, aux; int error, temp, error_prev, temp_prev;
      
      selectedStep = core.getSelectedValidStep(selectedStep);
      core = core.getValidCore();
      for(int i=0; i<core.getSteps().size(); i++){
          aux = core.getStepN(i).getPos().getError();
          if(errMin > aux)
              errMin = aux;
          if(errMax < aux)
              errMax = aux;
      }
      double s_error = (tam.height-d)/(errMax); // scale y-error
      double s_temp = (tam.width-d)/(core.getStepN(core.getSteps().size()-1).getTemp() + core.getStepN(0).getTemp()); // scale x-temperature
              
      y0 = y0 + (int)(errMax*s_error); // centre
      
      g.setColor (Color.GRAY);
      g.drawLine(x0, y0, x0+tam.width-d, y0); // axes
      g.drawLine(x0, y0 , x0, y0 - (int)(errMax*s_error));
      g.setColor(Color.RED);
      
      error = (int) (core.getStepN(0).getPos().getError() * s_error);
      temp = (int) (core.getStepN(0).getTemp() * s_temp);
      for(int i=0; i<core.getSteps().size(); i++){
          error_prev = error;
          temp_prev = temp;
          error = (int) (core.getStepN(i).getPos().getError() * s_error);
          temp = (int) (core.getStepN(i).getTemp() * s_temp);
          
          if(i == selectedStep)
               g.setColor (Color.BLUE);

          g.fillOval(x0 + temp - d/9, y0 - error - d/9, (int)(d/4.5), (int)(d/4.5)); // error vs temperature step
          
          g.setColor(Color.RED);
          if(i>0){
              g.setStroke(new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1, dashPattern, 0));
              g.drawLine(x0 + temp_prev, y0 - error_prev, x0 + temp, y0 - error);
              g.setStroke(strokeIni);
          }
               
      }
      
      //Draw scale
 
      g.setColor(Color.GRAY);
      aux = (errMin+errMax)/2;
      g.drawLine(x0-5, y0-(int)(aux*s_error), x0+5, y0-(int)(aux*s_error));
      g.drawString(Integer.toString((int)aux), x0-11, y0-(int)(aux*s_error)+11);
      
      g.drawLine(x0-5, y0-(int)(errMax*s_error), x0+5, y0-(int)(errMax*s_error));
      g.drawString(Integer.toString((int)errMax), x0-11, y0-(int)(errMax*s_error)+11);
      
      g.drawLine(x0-5, y0-(int)(errMin*s_error), x0+5, y0-(int)(errMin*s_error));
      g.drawString(Integer.toString((int)errMin), x0-11, y0-(int)(errMin*s_error)+11);

      double stepMin=core.getStepN(0).getTemp(); 
      double stepMax=core.getStepN(core.getSteps().size()-1).getTemp();
      double stepInt=core.getStepN((int)core.getSteps().size()/2).getTemp();

      g.drawLine(x0+(int)(stepInt*s_temp),y0-5,x0+(int)(stepInt*s_temp),y0+5);
      g.drawString(Integer.toString((int)stepInt), x0+(int)(stepInt*s_temp), y0-1);
      
      g.drawLine(x0+(int)(stepMax*s_temp),y0-5, x0+(int)(stepMax*s_temp),y0+5);
      g.drawString(Integer.toString((int)stepMax), x0+(int)(stepMax*s_temp), y0-1);
      
      g.drawLine(x0+(int)(stepMin*s_temp), y0-5, x0+(int)(stepMin*s_temp), y0+5);
      g.drawString(Integer.toString((int)stepMin), x0+(int)(stepMin*s_temp), y0-1);

    }
    
    public void paint(Graphics g){
        super.paint(getGraphics());
        paintComponent(g);
        plot();
    }

    private void plot(){
        if(site != null){
            int selectedCore = getSelectedCore();
            int selectedStep = coreList.getSelectedIndex();
            if (selectedStep == -1 )
                selectedStep = 0;
            Core core;
            if(stacking)
                core=stackingCore;
            else
                core=((Core)site.get(selectedCore));
            name = core.getName();
            //if(core.getComment().length()>2)
            //    name = name + ", " + core.getComment();
            name = name + "\nDrilling: "+core.getTrend()+", "+core.getPlunge()+"\nS0: "+core.getStrike()+", "+core.getDip();
            coreName.setText(name);
            stereonet(core, selectedStep);
            zijderveldPlot(core, selectedStep);
            intensityPlot(core, selectedStep);
            infoSelectedCore(selectedCore, selectedStep);
            pcaInfo(core);
        }
   }

    private void pcaInfo(Core core){
        Vector v; VD vd;  Position pos;
        String text = "DEC, INC, INT, MAD, STEP_MIN, STEP_MAX\n";
        if(tc)
            core = core.beddingCorrection();

       v = core.getInclCirc(); 
       if(!v.isEmpty()){
       for (int i=0; i<v.size(); i++){
           vd = (VD)v.get(i); pos = vd.getPos();
           pos.round();
           text = text + "Inclor circle: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + pos.getInt() +  ", " +  pos.getError() + ", " + vd.getStepIni() + ", " + vd.getStepEnd()+"\n";
       }}
       v = core.getInclDir();
       if(!v.isEmpty()){     
       for (int i=0; i<v.size(); i++){
           vd = (VD)v.get(i); pos = vd.getPos();
           pos.round();
           text = text + "Inclor direction: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + pos.getInt() +  ", " +  pos.getError() + ", " + vd.getStepIni() + ", " + vd.getStepEnd()+ "\n";
       }}
       v = core.getExclCirc();
       if(!v.isEmpty()){
       for (int i=0; i<v.size(); i++){
           vd = (VD)v.get(i); pos = vd.getPos();
           pos.round();
           text = text + "Exclor circle: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + pos.getInt() +  ", " +  pos.getError() + ", " + vd.getStepIni() + ", " + vd.getStepEnd()+ "\n";
       }}
       v = core.getExclDir();
       if(!v.isEmpty()){
       for (int i=0; i<v.size(); i++){
           vd = (VD)v.get(i); pos = vd.getPos();
           pos.round();
           text = text + "Exclor direction: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + pos.getInt() +  ", " +  pos.getError() + ", " + vd.getStepIni() + ", " + vd.getStepEnd()+ "\n";
       }}

      pcaText.setText(text);
    }
    
    private int getSelectedCore(){
        int selectedCore = 0, i;
        i = siteList.getSelectedIndex();
        if (i != -1 && i<index.size()){    
            selectedCore = ((Integer)index.getElementAt(i)).intValue();
        }else{
            i = finalSiteList.getSelectedIndex();
            if (i != -1 && i<finalIndex.size())
                selectedCore = ((Integer)finalIndex.getElementAt(i)).intValue();
        }
        return selectedCore;
    }
    
    private Vector finalSite(){
        Vector finalSite = new Vector();
        Core core;
        int ind;
        for(int i=0; i<finalIndex.size(); i++){
            ind = ((Integer)finalIndex.getElementAt(i)).intValue();
            core = (Core)siteIni.get(ind);
            core = core.getValidCore();
            finalSite.add(core);
        }
        return finalSite;
    }
    
    private Vector stackingSite(){
        Vector stackingSite = finalSite();
        if(stackingSite.isEmpty()){
            stackingSite = siteIni;
            System.out.println("stakinSite is empty");
        }
        stackingSite = Main.drillingCorrection(stackingSite);

        return stackingSite;
    }
    
    private void actualizeCoreDel(int[] indices){
        if(site != null && !stacking){
            int selectedCore = getSelectedCore();
            Core core = ((Core)site.get(selectedCore));
            Vector validSteps = core.getValidStep();
            for(int i=0; i<indices.length; i++){
                boolean value = (Boolean)validSteps.get(indices[i]);
                value = !value;
                validSteps.set(indices[i],value);
                if(!value)
                    insertedSteps.set(indices[i], false);
            }
            core.setValidStep(validSteps);
            site.set(selectedCore, core);
            initCoreList(selectedCore);                
            plot();
        }
        if(stacking){
            Vector validSteps = validStepsStaking;
            for(int i=0; i<indices.length; i++){
                boolean value = (Boolean)validSteps.get(indices[i]);
                value = !value;
                validSteps.set(indices[i],value);
                if(!value)
                    insertedSteps.set(indices[i], false);
            }
            validStepsStaking = validSteps;
            initCoreList(0);                
            plot();
        }
        int[] ind = coreList.getSelectedIndices();
        coreList.setSelectedIndex( (ind[ind.length-1] + 1) % ((Core)site.get(getSelectedCore())).getSteps().size());
    }    
    
    private void actualizeCoreIns(int[] indices){
        if(site != null){
            for(int i=0; i<indices.length; i++){
                boolean value = (Boolean)insertedSteps.get(indices[i]);
                if(stacking){
                    if((Boolean)validStepsStaking.get(indices[i]))
                         value = !value;
                }else{
                    if((Boolean)(((Core)site.get(getSelectedCore())).getValidStep()).get(indices[i]))
                        value = !value;
                }
                insertedSteps.set(indices[i],value);
            }   
            initCoreList(getSelectedCore());   
            plot();
            int[] ind = coreList.getSelectedIndices();
            coreList.setSelectedIndex( (ind[ind.length-1] + 1) % ((Core)site.get(getSelectedCore())).getSteps().size());
            
        }
    }        
   
    private void clearInsertedSteps(int size){
        insertedSteps = new Vector();
        for(int i=0; i<size; i++)
            insertedSteps.add(false);
        //clear pca
        //inclDir.clear(); exclDir.clear(); inclCirc.clear(); exclCirc.clear();
        //pcaText.setText("DEC, INC, INT, MAD, STEP_MIN, STEP_MAX\n");
    }
    private void  clearValidStepsStaking(){
        validStepsStaking = new Vector();
        if(stacking){
            for(int i=0; i<(Statistics.stacking(stackingSite())).getSteps().size(); i++)
                validStepsStaking.add(true);
        }            
    };
    private void clearAll(){
        tc = true;
        upNorth = false;
        stacking = false;
        af = false;
        siteListModel = new DefaultListModel();
        finalSiteListModel = new DefaultListModel();
        index = new DefaultListModel();
        finalIndex = new DefaultListModel();
        insertedSteps = new Vector(); validStepsStaking = new Vector();
        stackingCore = null;

    }
    
    public void setActualField(Position actualField){
        if (actualField == null)
            System.out.println("Present field is null");
        else
            System.out.println("Present field: " + actualField.getDec() + ", " + actualField.getInc());
        actualPos = actualField;
        plot();
    }

    public void paintComponent(Graphics g) {
        g=logoPanel.getGraphics();
        ImageIcon imag = new ImageIcon("logoVPD.jpg");
        g.drawImage(imag.getImage(), 0, 0,  imag.getIconWidth() ,  imag.getIconHeight(), null);
        logoPanel.paintComponents(g);
}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton actualField;
    private javax.swing.JButton addAllButton;
    private javax.swing.JButton addButton;
    private javax.swing.JButton clearAllPcaButton;
    private javax.swing.JButton clearPcaButton;
    private javax.swing.JList coreList;
    private javax.swing.JTextPane coreName;
    private javax.swing.JPanel corePanel;
    private javax.swing.JButton deleteStep;
    private javax.swing.JPanel errorPanel;
    private javax.swing.JButton excCircButton;
    private javax.swing.JButton excDirButton;
    private javax.swing.JButton exportDirectionsButton;
    private javax.swing.JButton exportGraphicsButton;
    private javax.swing.JMenuItem fileExit;
    private javax.swing.JMenu fileMenu24;
    private javax.swing.JList finalSiteList;
    private javax.swing.JMenuItem g2Append;
    private javax.swing.JMenuItem g2Open;
    private javax.swing.JButton incCircButton;
    private javax.swing.JButton incDirButton;
    private javax.swing.JButton insertStep;
    private javax.swing.JPanel intensityPanel;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenuBar jMenuBar25;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JLabel label;
    private javax.swing.JPanel logoPanel;
    private javax.swing.JButton lsaButton;
    private javax.swing.JMenuItem michiganAppend;
    private javax.swing.JMenuItem michiganOpen;
    private javax.swing.JPanel ortogonalPlot;
    private javax.swing.JPanel pcaPanel;
    private javax.swing.JTextArea pcaText;
    private javax.swing.JButton removeAllButton;
    private javax.swing.JButton removeButton;
    private javax.swing.JMenuItem romaAppend;
    private javax.swing.JMenuItem romaOpen;
    private javax.swing.JButton saveFinalSiteButton;
    private javax.swing.JList siteList;
    private javax.swing.JPanel sitePanel;
    private javax.swing.JButton stackingButton;
    private javax.swing.JTextPane stepInfo;
    private javax.swing.JTextPane stepName;
    private javax.swing.JPanel stereoPlot;
    private javax.swing.JButton tc_ntc;
    private javax.swing.JMenuItem uchannelsAppend;
    private javax.swing.JMenuItem uchannelsOpen;
    private javax.swing.JButton upN_upW;
    private javax.swing.JMenuItem utrechAppend;
    private javax.swing.JMenuItem utrechOpen;
    private javax.swing.JButton virtualButton;
    // End of variables declaration//GEN-END:variables
    
}
