package paldirvd;

import Jama.EigenvalueDecomposition;
import Jama.Matrix;
import java.util.Vector;

/***/

public class VirtualDirections {
    
    private static String RESULTANT = "R";
    private static String DIFFERENCE = "D";
    private static String PLANE = "P";
    private static String VECTOR = "V";
    
    static Vector virtualDirections(Vector site){
        
        Vector vds = new Vector();
        Core core;

         for(int numCore = 0; numCore<site.size(); numCore++){
             
             core = (Core)site.get(numCore);
             Vector steps = core.getSteps();
          
             for(int stepIni=0; stepIni<steps.size(); stepIni++){
               
                for(int stepEnd=(stepIni+1);stepEnd<=steps.size();stepEnd++){ 
                    vds = PCA(vds, steps, stepIni, stepEnd, core.getName());
                   // VD vd = (VD)vds.get(vds.size()-1);
                   // System.out.println("dec: " + vd.getPos().getDec() + "inc: " + vd.getPos().getInc());
                    
                }
            }
        }
        
        return vds;
    }
 
    public static Vector PCA(Vector vds, Vector steps, int stepIni, int stepEnd, String nameCore){ //Principal Components Analysis
        
        double x,y,z,XX,XY,XZ,YY,YZ,ZZ, x_mean, y_mean, z_mean;
        double step_ini = ((Step)steps.get(stepIni)).getTemp();
        double step_end = ((Step)steps.get(stepEnd-1)).getTemp();

        //EXCLOR, DIFFERENCE (el centroide de la matriz es el punto medio)
        x_mean = 0; y_mean = 0; z_mean = 0; x = 0; y = 0; z = 0; XX = 0; XY = 0; XZ = 0; YY = 0; YZ = 0; ZZ = 0;
        for(int i=stepIni; i<stepEnd; i++){
            x_mean = x_mean + ((Step)steps.get(i)).getPos().getX();
            y_mean = y_mean + ((Step)steps.get(i)).getPos().getY();
            z_mean = z_mean + ((Step)steps.get(i)).getPos().getZ();
        }
        x_mean = x_mean / (stepEnd-stepIni);
        y_mean = y_mean / (stepEnd-stepIni);
        z_mean = z_mean / (stepEnd-stepIni);
        
        Position pos_mean = new Position(x_mean, y_mean, z_mean, 0);
        //pos_mean = pos_mean.normalize();
        
        for(int i=stepIni; i<stepEnd; i++){
            x = ((Step)steps.get(i)).getPos().getX();
            y = ((Step)steps.get(i)).getPos().getY();
            z = ((Step)steps.get(i)).getPos().getZ();
            XX = XX + (x-x_mean)*(x-x_mean);
            XY = XY + (x-x_mean)*(y-y_mean);
            XZ = XZ + (x-x_mean)*(z-z_mean);
            YY = YY + (y-y_mean)*(y-y_mean);
            YZ = YZ + (y-y_mean)*(z-z_mean);
            ZZ = ZZ + (z-z_mean)*(z-z_mean);
        }
        
        double[][] array_dif = {{XX, XY, XZ},
                            {XY, YY, YZ},
                            {XZ, YZ, ZZ}};                    
        Matrix P_dif = new Matrix(array_dif); 

        //INCLOR, RESULTANT (el centroide de la matriz es el origen)
        x = 0; y = 0; z = 0; XX = 0; XY = 0; XZ = 0; YY = 0; YZ = 0; ZZ = 0;
        for(int i=stepIni; i<stepEnd; i++){
            x = ((Step)steps.get(i)).getPos().getX();
            y = ((Step)steps.get(i)).getPos().getY();
            z = ((Step)steps.get(i)).getPos().getZ();
            XX = XX + x*x;
            XY = XY + x*y;
            XZ = XZ + x*z;
            YY = YY + y*y;
            YZ = YZ + y*z;
            ZZ = ZZ + z*z;
        }
        //System.out.println("stepIni: " + step_ini + ", stepEnd: " + step_end);
        //System.out.println("xx: " + XX + ", xy: " + XY +  ", xz: " + XZ + ", yy: " + YY + ", yz: " + YZ + ", zz: " + ZZ);

        double[][] array_res = {{XX, XY, XZ},
                            {XY, YY, YZ},
                            {XZ, YZ, ZZ}};
        Matrix P_res = new Matrix(array_res);
        
        //p1-pn to know the direcction of the vector
        double[] p_dif = {((Step)steps.get(stepIni)).getPos().getX() - ((Step)steps.get(stepEnd-1)).getPos().getX(),
                      ((Step)steps.get(stepIni)).getPos().getY() - ((Step)steps.get(stepEnd-1)).getPos().getY(),
                      ((Step)steps.get(stepIni)).getPos().getZ() - ((Step)steps.get(stepEnd-1)).getPos().getZ()};
        //p1-pn to know the direcction of the vector
        double[] p_result = {((Step)steps.get(stepIni)).getPos().getX(),
                      ((Step)steps.get(stepIni)).getPos().getY() ,
                      ((Step)steps.get(stepIni)).getPos().getZ() };
        
        //pca intensity --> Intensity(v_end - v_ini) as in paldir
        x = ((Step)steps.get(stepIni)).getPos().getX();
        y = ((Step)steps.get(stepIni)).getPos().getY();
        z = ((Step)steps.get(stepIni)).getPos().getZ();
        double intensity = (new Position(x,y,z,0)).getInt();
        
        vds = eigenValues(P_res, p_result, stepIni, stepEnd, step_ini, step_end, RESULTANT, vds, nameCore, pos_mean, intensity);
              
        x = x - ((Step)steps.get(stepEnd-1)).getPos().getX();
        y = y - ((Step)steps.get(stepEnd-1)).getPos().getY();
        z = z - ((Step)steps.get(stepEnd-1)).getPos().getZ();
        intensity = (new Position(x,y,z,0)).getInt();

        if(stepEnd-stepIni>1) //minimum two directions are needed to calculate a diference direction
            vds = eigenValues(P_dif, p_dif, stepIni, stepEnd, step_ini, step_end, DIFFERENCE, vds, nameCore, pos_mean, intensity);

        return vds;
    }
    
    private static Vector eigenValues(Matrix P, double[] p, int stepIni, int stepEnd, double step_ini, double step_end, String resDif, Vector vds, String nameCore, Position pos_mean, double intensity){
        
        double dot, x, y, z, d3, d2, d1, aux, MADline, MADplane;
        
        EigenvalueDecomposition eigen = P.eig(); 
        Matrix d =  eigen.getD();
        
        int posMax = 0, posInt = 1, posMin = 2, auxPos;
        d3 = Math.abs(d.get(posMin, posMin));
        d2 = Math.abs(d.get(posInt, posInt));
        d1 = Math.abs(d.get(posMax, posMax));
        double[] ordena = {d3,d2,d1};
        int[] ordenaPos = {posMin,posInt,posMax};
        for(int i=0; i<3; i++){
            for(int j=i; j<3; j++){
                if (ordena[i] < ordena[j]){
                     aux = ordena[i];
                     ordena[i] = ordena[j];
                     ordena[j] = aux;
                     auxPos = ordenaPos[i];
                     ordenaPos[i] = ordenaPos[j];
                     ordenaPos[j] = auxPos;
                }
            }  
        }
        d3 = ordena[2]; d2 = ordena[1]; d1 = ordena[0]; 
        posMin = ordenaPos[2]; posInt = ordenaPos[1]; posMax = ordenaPos[0];
        //System.out.println("stepIni: " + step_ini + ", stepEnd: " + step_end);

 
        if(d1 != 0)
            MADline = Math.toDegrees(Math.atan(Math.sqrt((d3 + d2)/d1)));
        else    
            MADline = 90;
        if(d2 != 0 && d1 != 0)
            MADplane = Math.toDegrees(Math.atan(Math.sqrt(d3/d2 + d3/d1)));
            
        else 
            MADplane = 90;
        
        x = eigen.getV().get(0,posMax);
        y = eigen.getV().get(1,posMax);
        z = eigen.getV().get(2,posMax);
        dot = p[0]*x + p[1]*y + p[2]*z; //The vector must be in the same direction as the original. Producto vectorial positivo = vectores paralelos
        if(dot < 0){
            x = -x; y = -y; z = -z;
        }
        Position line = new Position(x,y,z, intensity, MADline); 
        //System.out.println("LINE, x: " + x + ",y: " + y + ",z: " + z);
        //System.out.println("LINE, dec: " + line.getDec() + ",inc: " + line.getInc());
       
        x = eigen.getV().get(0,posMin);
        y = eigen.getV().get(1,posMin);
        z = eigen.getV().get(2,posMin);
       
        /*if(x > 0){ //Change to lower hemisphere (positive)
            x = -x; y = -y; z = -z;
        }*/

        Position plane = new Position(x,y,z, 0, MADplane);

        //VD (int resultant_difference, int plane_line, int step_ini, int step_end, int num_steps, Position position)
        vds.add( new VD(nameCore, resDif, VECTOR, step_ini, step_end, stepEnd-stepIni, line, pos_mean) );
        vds.add( new VD(nameCore, resDif, PLANE, step_ini, step_end, stepEnd-stepIni, plane, pos_mean) );
        
        return vds;
    }

    public static Vector Filter(Vector vds, double stepMin, double stepMax, int numSteps, double minInt, double maxInt, double minMad, double maxMad){
        Vector vdFilt = new Vector();
        String planeLine;
        int num_steps;
        double stepIni, stepEnd, intensity, error;
        //System.out.println("SE AÑADE A LA LISTA DE VD TRAS EL FILTRADO (minStep: "+stepMin+", maxStep: "+stepMax+", numMinSteps: "+numSteps+")");
        for(int i=0; i<vds.size(); i++){
            planeLine = ((VD)vds.get(i)).getPlaneLine();
            stepIni = ((VD)vds.get(i)).getStepIni();
            stepEnd = ((VD)vds.get(i)).getStepEnd();
            num_steps = ((VD)vds.get(i)).getNumSteps();
            intensity = ((VD)vds.get(i)).getPos().getInt();
            error = ((VD)vds.get(i)).getPos().getError();
            if((stepIni >= stepMin) && (stepEnd <= stepMax) && (num_steps >= numSteps)  && (error >= minMad)&& (error <= maxMad)){
                if((planeLine.equals(VECTOR) && (intensity >= minInt)&& (intensity <= maxInt)) || planeLine.equals(PLANE)){ //Intensity only afects directions
                    vdFilt.add(vds.get(i));
                    //System.out.println("sepIni: " +stepIni+", stepEnd: "+stepEnd+", numSteps: "+num_steps+", planeLine: " +((VD)vds.get(i)).getPlaneLine()+", resDif: "+((VD)vds.get(i)).getResDif());
                }
                }
        }
        return vdFilt;
    }
    
       public static Vector getRV(Vector vds){ //Get only resultant directions
       Vector vdsRV = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(RESULTANT.equals(vd.getResDif()) && VECTOR.equals(vd.getPlaneLine())){
               vdsRV.add(vds.get(i));
           }
       }
       return vdsRV;
    }
    public static Vector getDV(Vector vds){ //Get only difference directions
       Vector vdsDV = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(DIFFERENCE.equals(vd.getResDif()) && VECTOR.equals(vd.getPlaneLine())){
               vdsDV.add(vds.get(i));
           }
       }
       return vdsDV;
    }
    public static Vector getRP(Vector vds){ //Get only resultant circles
       Vector vdsRP = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(RESULTANT.equals(vd.getResDif()) && PLANE.equals(vd.getPlaneLine())){
               vdsRP.add(vds.get(i));
           }
       }
       return vdsRP;
    }
    public static Vector getDP(Vector vds){ //Get only difference circles
       Vector vdsDP = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(DIFFERENCE.equals(vd.getResDif()) && PLANE.equals(vd.getPlaneLine())){
               vdsDP.add(vds.get(i));
           }
       }
       return vdsDP;
    }

    public static Vector getRV(Vector vds, boolean tc){ //Get only resultant directions
       Vector vdsRV = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(RESULTANT.equals(vd.getResDif()) && VECTOR.equals(vd.getPlaneLine())){
               vdsRV.add(vds.get(i));
           }
       }
       return vdsRV;
    }
    public static Vector getDV(Vector vds, boolean tc){ //Get only difference directions
       Vector vdsDV = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(DIFFERENCE.equals(vd.getResDif()) && VECTOR.equals(vd.getPlaneLine())){
               vdsDV.add(vds.get(i));
           }
       }
       return vdsDV;
    }
    public static Vector getRP(Vector vds, boolean tc){ //Get only resultant circles
       Vector vdsRP = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(RESULTANT.equals(vd.getResDif()) && PLANE.equals(vd.getPlaneLine())){
               vdsRP.add(vds.get(i));
           }
       }
       return vdsRP;
    }
    public static Vector getDP(Vector vds, boolean tc){ //Get only difference circles
       Vector vdsDP = new Vector(); VD vd;
       for(int i=0; i<vds.size(); i++){
           vd=(VD)vds.get(i);
           if(DIFFERENCE.equals(vd.getResDif()) && PLANE.equals(vd.getPlaneLine())){
               vdsDP.add(vds.get(i));
           }
       }
       return vdsDP;
    }
}
